// dibdoc.cpp : CDibDoc NX̃Cve[V
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
// 
// ̃\[X R[h Microsoft Foundation Class t@XсA
// ֘AIC hLg̕⑫݂̂ړIƂĂ܂B
// Microsoft Foundation Class iɊւڂ͂̃hLg
// QƂĂB
//

//..... write file.Close() ́@^C~Oɒ jpegfile.lib 
//      Ł@P open/close 玖O closeKvB

/*
#include <windowsx.h>  // for GlobalAllocPtr  */

#include "stdafx.h"
#include "diblook.h"
#include <limits.h>

#include "dibdoc.h"

#include "JpegFile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
#define DIB_HEADER_MARKER   ((WORD) ('M' << 8) | 'B')
/////////////////////////////////////////////////////////////////////////////
// CDibDoc

IMPLEMENT_DYNCREATE(CDibDoc, CDocument)

BEGIN_MESSAGE_MAP(CDibDoc, CDocument)
	//{{AFX_MSG_MAP(CDibDoc)
	ON_COMMAND(ID_EDIT_COPY3R_DOC, OnEditCopy3R_DOC)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY3R_DOC, OnUpdateEditCopy3R_DOC)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDibDoc NX̍\z/

CDibDoc::CDibDoc()
{
	m_hDIB = NULL;
	m_palDIB = NULL;
	m_sizeDoc = CSize(1,1);     // CScrollView ܂쐬邽߂̃_~[l
    jpeg_SW = 0;
	m_buf = NULL;
	m_lpBMFH  = NULL;
    m_lpBMIH  = NULL;
    m_lpBMI   = NULL;
}

CDibDoc::~CDibDoc()
{
	if (m_hDIB != NULL)
	{
		::GlobalFree((HGLOBAL) m_hDIB);
	}
	if (m_palDIB != NULL)
	{
		delete m_palDIB;
	}
}

BOOL CDibDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;
	return TRUE;
}

void CDibDoc::InitDIBData()
{
	if (m_palDIB != NULL)
	{
		delete m_palDIB;
		m_palDIB = NULL;
	}
	if (m_hDIB == NULL)
	{
		return;
	}
	// hLg TCY̐ݒ
	LPSTR lpDIB = (LPSTR) ::GlobalLock((HGLOBAL) m_hDIB);
	if (::DIBWidth(lpDIB) > INT_MAX ||::DIBHeight(lpDIB) > INT_MAX)
	{
		::GlobalUnlock((HGLOBAL) m_hDIB);
		::GlobalFree((HGLOBAL) m_hDIB);
		m_hDIB = NULL;
		CString strMsg;
		strMsg.LoadString(IDS_DIB_TOO_BIG);
		MessageBox(NULL, strMsg, NULL, MB_ICONINFORMATION | MB_OK);
		return;
	}
	m_sizeDoc = CSize((int) ::DIBWidth(lpDIB), (int) ::DIBHeight(lpDIB));
	::GlobalUnlock((HGLOBAL) m_hDIB);
	// pbg̃Rs[쐬܂B
	m_palDIB = new CPalette;
	if (m_palDIB == NULL)
	{
		// ł͖{ɏłB
		::GlobalFree((HGLOBAL) m_hDIB);
		m_hDIB = NULL;
		return;
	}
	if (::CreateDIBPalette(m_hDIB, m_palDIB) == NULL)
	{
		// DIB ̓pbgĂȂ\܂B
		delete m_palDIB;
		m_palDIB = NULL;
		return;
	}
}


BOOL CDibDoc::OnOpenDocument(LPCTSTR lpszPathName)
{
	CFile file;
	CFileException fe;
	if (!file.Open(lpszPathName, CFile::modeRead | CFile::shareDenyWrite, &fe))
	{
		ReportSaveLoadException(lpszPathName, &fe,
			FALSE, AFX_IDP_FAILED_TO_OPEN_DOC);
		return FALSE;
	}

	DeleteContents();
	BeginWaitCursor();
 
	jpeg_SW = 0;
	int sw = 0;
	fileName=file.GetFilePath();
	CString ext=fileName.Right(4);
	if (!ext.CompareNoCase(".JPG"))	{
        sw = 1;
		jpeg_SW = 1;
	}
    
    if (sw == 1) {
		JPEG_reader();
		file.Close();
		SetModifiedFlag(FALSE);
	    SetPathName(lpszPathName);
	    return TRUE;
	}

	jpeg_SW = 0;
	// VACYp̌Ăяo ReadDIBFile ֐ɒu܂B
	TRY
	{
		m_hDIB = ::ReadDIBFile(file);
	}
	CATCH (CFileException, eLoad)
	{
		file.Abort(); // OX[܂B
		EndWaitCursor();
		ReportSaveLoadException(lpszPathName, eLoad,
			FALSE, AFX_IDP_FAILED_TO_OPEN_DOC);
		m_hDIB = NULL;
		return FALSE;
	}
	END_CATCH

	InitDIBData();
	EndWaitCursor();
//pointers for internal use
	if (m_hDIB != NULL)
	{
        m_lpBMFH  = (LPBITMAPFILEHEADER)m_hDIB;
        m_lpBMIH  = (LPBITMAPINFOHEADER)m_hDIB;
        m_lpBMI   = (LPBITMAPINFO)m_hDIB;
	}

	if (m_hDIB == NULL)
	{
		// DIB tH[}bgł͂Ȃ\܂B
		CString strMsg;
		strMsg.LoadString(IDS_CANNOT_LOAD_DIB);
		MessageBox(NULL, strMsg, NULL, MB_ICONINFORMATION | MB_OK);
		return FALSE;
	}
	SetPathName(lpszPathName);
	SetModifiedFlag(FALSE);     // C𖳌ɂĎn߂܂B
	return TRUE;
}


BOOL CDibDoc::OnSaveDocument(LPCTSTR lpszPathName)
{
	CFile file;
	CFileException fe;

	if (!file.Open(lpszPathName, CFile::modeCreate |
	  CFile::modeReadWrite | CFile::shareExclusive, &fe))
	{
		ReportSaveLoadException(lpszPathName, &fe,
			TRUE, AFX_IDP_INVALID_FILENAME);
		return FALSE;
	}
	BOOL bSuccess = FALSE;

////////////////////////////////////////
//	CString fileName;
	int sw = 0;
	fileName=file.GetFilePath();
	CString ext=fileName.Right(4);
	if (!ext.CompareNoCase(".JPG"))
	{
		sw = 1;
	}
    if (sw == 1 && 	jpeg_SW == 0) {
		file.Close();
//		SetModifiedFlag(FALSE);
//	    SetPathName(lpszPathName);
//	    return TRUE;
		goto byp01;
	}
	if (sw == 1 && 	jpeg_SW == 1) {
		file.Close();
//		SetModifiedFlag(FALSE);
//	    SetPathName(lpszPathName);
//	    return TRUE;
		goto byp01;
	}
	if (sw == 1 && 	jpeg_SW == 1) {//@M_BUF NOTHING 9 ERROR
		file.Close();
		JPEG_writer();
        JPEG_reader();
		SetModifiedFlag(FALSE);
	    SetPathName(lpszPathName);
	    return TRUE;
	}

///////////// jpg ȊO ENTER ///////////
	// VACYp̌Ăяo SaveDIB ֐ɒu܂B
//	BOOL bSuccess = FALSE;
	TRY
	{
		BeginWaitCursor();
		bSuccess = ::SaveDIB(m_hDIB, file);
		file.Close();
	}
	CATCH (CException, eSave)
	{
		file.Abort(); // OX[܂B
		EndWaitCursor();
		ReportSaveLoadException(lpszPathName, eSave,
			TRUE, AFX_IDP_FAILED_TO_SAVE_DOC);
		return FALSE;
	}
	END_CATCH

	EndWaitCursor();
	SetModifiedFlag(FALSE);     // COɖ߂܂B

	if (!bSuccess)
	{
		// ̃X^C DIB ܂B([h̓T|[gĂ܂Aۑł܂)
		// ܂ SaveDIB ̖̑肩܂B
		CString strMsg;
		strMsg.LoadString(IDS_CANNOT_SAVE_DIB);
		MessageBox(NULL, strMsg, NULL, MB_ICONINFORMATION | MB_OK);
	}
	return bSuccess;
////////////////////// sw == 1
byp01:
///////////// jpg ȊO EXIT
//////////////////////////////////////////////////////////////////////////
// ONLY.......m_lpBMIH->biCompression = BI_RGB;
///////////// jpg only ENTER
//jpg_write_area:
 	BITMAPFILEHEADER bmfHdr;   //. rbg}bvt@C̃wb_[
	LPBITMAPINFOHEADER lpBI;   //. DIB ̏i[p\̂̃|C^
	DWORD dwDIBSize;

	if (m_hDIB == NULL)
		return FALSE;

	lpBI = (LPBITMAPINFOHEADER) ::GlobalLock((HGLOBAL) m_hDIB);
	if (lpBI == NULL)
		return FALSE;

	if (!IS_WIN30_DIB(lpBI))	//. 3.0łȂDIB͕ۑȂ
	{
		::GlobalUnlock((HGLOBAL) m_hDIB);
		return FALSE;
	}

	//. t@C̃wb_[\̂̃f[^쐬
	bmfHdr.bfType = DIB_HEADER_MARKER;  //. t@C^Cv"BM"

	dwDIBSize = *(LPDWORD)lpBI + ::PaletteSize((LPSTR)lpBI);

	if ((lpBI->biCompression == BI_RLE8) || (lpBI->biCompression == BI_RLE4))
		dwDIBSize += lpBI->biSizeImage;		//. RLEkrbg}bv
	else
	{
		DWORD dwBmBitsSize;

		dwBmBitsSize = WIDTHBYTES((lpBI->biWidth)*((DWORD)lpBI->biBitCount)) * lpBI->biHeight;

		dwDIBSize += dwBmBitsSize;

		lpBI->biSizeImage = dwBmBitsSize;
	}
//KoKo:  
	bmfHdr.bfSize = dwDIBSize + sizeof(BITMAPFILEHEADER) - sizeof(BITMAPFILEHEADER);
	bmfHdr.bfReserved1 = 0;
	bmfHdr.bfReserved2 = 0;
//KoKo:
	bmfHdr.bfOffBits = (DWORD)sizeof(BITMAPFILEHEADER)
						+ lpBI->biSize
						+ PaletteSize((LPSTR)lpBI);
/////////////////////////////////////////////////////////////////////
	int m_bufsw = 1;
	int DisMsg  = 1;
	BYTE *m_buf;
	if ((lpBI->biCompression == BI_RLE8) || (lpBI->biCompression == BI_RLE4))
    {
        AfxMessageBox("Sorry / Compressed file  jpegϊɔΉłB");
        m_bufsw = 2;
	}
		if (lpBI->biBitCount == 1)
    {
        AfxMessageBox("Sorry / biBitCount == 1 / file  jpegϊɔΉłB");
        m_bufsw = 2;
    }
	if (lpBI->biBitCount == 2)
    {
        AfxMessageBox("Sorry / biBitCount == 2 / file  jpegϊɔΉłB");
        m_bufsw = 2;
    }
	if (lpBI->biBitCount == 4)
    {
        AfxMessageBox("Sorry / biBitCount == 4 / file  jpegϊɔΉłB");
        m_bufsw = 2;
    }
	if (lpBI->biBitCount == 8)
    {
        AfxMessageBox("Sorry / biBitCount == 8 / file  jpegϊɔΉłB");
        m_bufsw = 2;
    }
	if (lpBI->biBitCount == 16)
    {
        AfxMessageBox("Sorry / biBitCount == 16 / file  jpegϊɔΉłB");
        m_bufsw = 2;
    }
	if (lpBI->biBitCount == 32)
    {
        AfxMessageBox("Sorry / biBitCount == 32 / file  jpegϊɔΉłB");
        m_bufsw = 2;
    }
	if (lpBI->biBitCount != 24)
    {
        AfxMessageBox("Sorry / biBitCount != 24 / file  jpegϊɔΉłB");
        m_bufsw = 2;
    }
//////////////////////////////////////
if (m_bufsw == 1)
{
//	CMemFile freplica(6666666);
	CMemFile freplica;
//  wb_[
	freplica.Write((LPSTR)&bmfHdr, sizeof(BITMAPFILEHEADER));
  /*freplica.WriteHuge(lpBI, dwDIBSize);*/
	freplica.Write(lpBI, dwDIBSize);
	freplica.SeekToBegin();
	BITMAP inBM;
	BYTE m1,m2;
    long filesize;
    short res1,res2;
    long pixoff;
    long bmisize;                    
    long compression;
    unsigned long sizeimage;
    long xscale, yscale;
    long colors;
    long impcol;
// for safety
	UINT MM_width;
	UINT MM_height;
    MM_width = 0;
	MM_height = 0;
	CString m_errorText;
	m_errorText="OK";
	UINT m_bytesRead;
	m_bytesRead=0;
	FILE *fpp;
	long rc;
	rc = 0L;
	if (fpp==NULL) {
		CString msg;                    
		msg="Can't open file for reading ";
		m_errorText=msg;
	} else {
		freplica.Read((BYTE  *)&(m1),1);
		m_bytesRead+=1;
		if (rc==-1) {m_errorText="Read Error!"; }
		freplica.Read((BYTE  *)&(m2),1);
		m_bytesRead+=1;
		if (rc==-1) m_errorText="Read Error!";
		if ((m1!='B') || (m2!='M')) {
			m_errorText="Not a valid BMP File";
        }
////////////////////////////////////////////////////////////
		freplica.Read((long  *)&(filesize),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((int  *)&(res1),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((int  *)&(res2),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(pixoff),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(bmisize),4);	
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(inBM.bmWidth),4);	
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(inBM.bmHeight),4);	
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((int  *)&(inBM.bmPlanes),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((int  *)&(inBM.bmBitsPixel),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(compression),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(sizeimage),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(xscale),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(yscale),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(colors),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(impcol),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
///////////////////////////////////////////////////////////
//	i don't do RLE files
		if (compression!=BI_RGB) {
	    	m_errorText="This is a compressed file.";
	    }
		if (colors == 0) {
			colors = 1 << inBM.bmBitsPixel;
		}
////////////////////////////////////////////////////////////
// read colormap
		RGBQUAD *colormap = NULL;
		switch (inBM.bmBitsPixel) {
		case 24:
			break;
// read pallete 
		case 1:
			break;
		case 4:
			break;
		case 8:
//			break;
			colormap = new RGBQUAD[colors];
			if (colormap==NULL) {
				m_errorText="Out of memory";
			}
			int i;
			for (i=0;i<colors;i++) {
				BYTE r,g,b, dummy;
		        freplica.Read((BYTE *)&(b),1);
//KoKo:
    			m_bytesRead++;
				if (rc!=1) {
					m_errorText="Read Error!";	
					delete [] colormap;
				}
				freplica.Read((BYTE  *)&(g),1);
				m_bytesRead++;
				if (rc!=1) {
					m_errorText="Read Error!";	
					delete [] colormap;
				}
				freplica.Read((BYTE  *)&(r),1);
				m_bytesRead++;
				if (rc!=1) {
					m_errorText="Read Error!";	
					delete [] colormap;
				}
				freplica.Read((BYTE  *)&(dummy),1);
				m_bytesRead++;
				if (rc!=1) {
					m_errorText="Read Error!";	
					delete [] colormap;
				}
				colormap[i].rgbRed=r;
				colormap[i].rgbGreen=g;
				colormap[i].rgbBlue=b;
			}
			break;
		}
		if ((long)m_bytesRead>pixoff) {
			m_errorText="Corrupt palette";
			delete [] colormap;
		}
//KoKo:
		while ((long)m_bytesRead<pixoff) {
			char dummy;
			freplica.Read(&dummy,1);
			m_bytesRead++;
		}
		int w=inBM.bmWidth;
		int h=inBM.bmHeight;
// set the output params
		MM_width = w;
		MM_height = h;
		long row_size = w * 3;
		long bufsize = (long)w * 3 * (long)h;
//KoKo:
////////////////////////////////////////////////////////////
// alloc our buffer
		m_buf=(BYTE *) new BYTE [bufsize];
		if (m_buf==NULL) {
			m_errorText="Memory alloc Failed";
		} else {
////////////////////////////////////////////////////////////
//	read it
			long row=0;
			long rowOffset=0;
// read rows in reverse order
			for (row=inBM.bmHeight-1;row>=0;row--) {
// which row are we working on?
				rowOffset=(long unsigned)row*row_size;						      
				if (inBM.bmBitsPixel==24) {
					for (int col=0;col<w;col++) {
						long offset = col * 3;
						char pixel[3];
                        if 	(freplica.Read((void  *)(pixel),3)==3) {
// we swap red and blue here
							*(m_buf + rowOffset + offset + 0)=pixel[2];// r
							*(m_buf + rowOffset + offset + 1)=pixel[1];// g
							*(m_buf + rowOffset + offset + 2)=pixel[0];// b
						}
					}
					m_bytesRead+=row_size;
// read DWORD padding
					while ((m_bytesRead-pixoff)&3) {
						char dummy;
						if (freplica.Read(&dummy,1)!=1) {
							m_errorText="Read Error";
							delete [] m_buf;
						}
                        if (m_buf==NULL) 
						{
                           AfxMessageBox
						  ("m_buf nothing Write Error....@");
						}
						m_bytesRead++;
					}
				} else {	// 1, 4, or 8 bit image
////////////////////////////////////////////////////////////////
// pixels are packed as 1 , 4 or 8 bit vals. need to unpack them
					int bit_count = 0;
					UINT mask = (1 << inBM.bmBitsPixel) - 1;
					BYTE inbyte=0;
					for (int col=0;col<w;col++) {
						int pix=0;
// if we need another byte
						if (bit_count <= 0) {
							bit_count = 8;
						    if (freplica.Read(&inbyte,1)!=1) {
							    m_errorText="Read Error";
								delete [] m_buf;
								delete [] colormap;
	                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
			("m_buf nothing Write Error...A");
								}
							}
							m_bytesRead++;
						}
// keep track of where we are in the bytes
						bit_count -= inBM.bmBitsPixel;
						pix = ( inbyte >> bit_count) & mask;
// lookup the color from the colormap - stuff it in our buffer
// swap red and blue
			*(m_buf + rowOffset + col * 3 + 2) = colormap[pix].rgbBlue;
			*(m_buf + rowOffset + col * 3 + 1) = colormap[pix].rgbGreen;
			*(m_buf + rowOffset + col * 3 + 0) = colormap[pix].rgbRed;
					}
// read DWORD padding
					while ((m_bytesRead-pixoff)&3) {
						char dummy;
						if (freplica.Read(&dummy,1)!=1) {
							m_errorText="Read Error";
							delete [] m_buf;
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
			   ("m_buf nothing Write Error...B");
								}
							if (colormap)
								delete [] colormap;
						}
//KoKo:
    						m_bytesRead++;
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
			   	("m_buf nothing Write Error...C");
								}
					}
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
				("m_buf nothing Write Error...D");
								}
				}
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
				("m_buf nothing Write Error...E");
								}
			}
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
				("m_buf nothing Write Error...F");
								}
		}
		if (colormap) {
			delete [] colormap;
		}
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
			    ("m_buf nothing Write Error...G");
								}
    }
    if ((m_buf==NULL) && (DisMsg == 1))
	{
        AfxMessageBox("m_buf nothing Write Error...H");
	}
	JpegFile::BGRFromRGB(m_buf, lpBI->biWidth , lpBI->biHeight);
	JpegFile::VertFlipBuf(m_buf, lpBI->biWidth  * 3, lpBI->biHeight);
/////////////////////////////////////  H13.08/14 ADD m_buf ReMake END
/////////////////////////////////////////////////////////////////////
	// we vertical flip for display. undo that.
	JpegFile::VertFlipBuf(m_buf, lpBI->biWidth * 3, lpBI->biHeight);
	// we swap red and blue for display, undo that.
	JpegFile::BGRFromRGB(m_buf, lpBI->biWidth, lpBI->biHeight);
	//  ̒ open/close
	BOOL ok=JpegFile::RGBToJpegFile(fileName, 
									m_buf,
									lpBI->biWidth,
									lpBI->biHeight,
									TRUE, 
									75);			// quality value 1-100.
}
	::GlobalUnlock((HGLOBAL) m_hDIB);
///////////// jpg only EXIT
	EndWaitCursor();
	SetModifiedFlag(FALSE);
    return TRUE;
//////////////////////
}

void CDibDoc::ReplaceHDIB(HDIB hDIB)
{
	if (m_hDIB != NULL)
	{
		::GlobalFree((HGLOBAL) m_hDIB);
	}
	m_hDIB = hDIB;
}

BOOL CDibDoc::JPEG_reader()
{
///////////// jpg only ENTER
	if (m_buf!=NULL) {
		m_buf=NULL;
  	}
	m_width = 0;
	m_height = 0;
	jpeg_SW = 1;

	//   wide height    om_buf...dummy run
	m_buf= JpegFile::JpegFileToRGB(fileName, &m_width, &m_height);
	//////////////////////
	// set up for display
	// do this before DWORD-alignment!!!
	// this works on packed (not DWORD-aligned) buffers
	// swap red and blue for display
	JpegFile::BGRFromRGB(m_buf, m_width, m_height);
	// vertical flip for display
	JpegFile::VertFlipBuf(m_buf, m_width * 3, m_height);
//////////////////@H13.7/6 }@///////////////////////

/////////////////////////////////////////////////////////
	short res1=0;
    short res2=0;
    long pixoff=54;
    long compression=0;
    long cmpsize=0;
    long colors=0;
    long impcol=0;
	char m1='B';
	char m2='M';
	CString m_errorText;
	m_errorText="OK";

	DWORD widthDW = WIDTHBYTES(m_width * 24);

	long bmfsize=sizeof(BITMAPFILEHEADER) 
	           + sizeof(BITMAPINFOHEADER) +
  						widthDW * m_height;	
	long byteswritten=0;
    long byteswritten2=0;
	BITMAPINFOHEADER header;
  	header.biSize=40; 						// header size
	header.biWidth=m_width;
	header.biHeight=m_height;
	header.biPlanes=1;
	header.biBitCount=24;					// RGB encoded, 24 bit
	header.biCompression=BI_RGB;			// no compression
	header.biSizeImage=0;
	header.biXPelsPerMeter=0;
	header.biYPelsPerMeter=0;
	header.biClrUsed=0;
	header.biClrImportant=0;


	long roww=0;
	long rowwidx;
	long roww_size;
	roww_size=header.biWidth*3;
// KoKo: KoKo: KoKo: H.18/07/27
    // DIB ̍śADWORD EŏIKv
    int bmp_row_bytes = (( ( header.biWidth * 3 ) + 3 ) / 4) * 4;
    int bmp_image_size = bmp_row_bytes * header.biHeight;
 
	// DWORD E␳
	int iHGap = bmp_row_bytes - (header.biWidth*3);

	UINT Dis_rowsize = 0;
	UINT Doc_toggle = 0;
	UINT Dis_toggle = 0;
	UINT buf_scale = 0;
//byp0:
	for (roww=0;roww<(header.biHeight+iHGap-1);roww++) {
		rowwidx=(long unsigned)roww*roww_size;						      
		// pad to DWORD
		for (DWORD count=roww_size;
             count<widthDW- sizeof(BITMAPINFOHEADER)-iHGap;count++) {
/////// H180728

/////// H180728
			char dummy=0;
		}
	}

	FILE *fp = NULL;
    CMemFile freplica(6666666);
	if (fp==NULL) {
		m_errorText="Can't open file for writing";
	}
// should probably check for write errors here...
	freplica.Write((BYTE  *)&m1, 1);
	freplica.Write((BYTE  *)&m2, 1);
	freplica.Write((long  *)&bmfsize, 4);
	freplica.Write((int  *)&res1, 2);
	freplica.Write((int  *)&res2, 2);
	freplica.Write((long  *)&pixoff, 4);
    byteswritten2 = byteswritten;
	freplica.Write((BITMAPINFOHEADER *)&header, sizeof(BITMAPINFOHEADER));
	byteswritten+=sizeof(BITMAPINFOHEADER);
	long row=0;
	long rowidx;
	long row_size;
	row_size=header.biWidth*3;
	for (row=0;row<header.biHeight;row++) {
		rowidx=(long unsigned)row*row_size;						      
		// write a row
    	freplica.Write((void  *)(m_buf + rowidx), row_size);
		byteswritten+=row_size;	
		// pad to DWORD
		for (DWORD count=row_size;count<widthDW;count++) {
			char dummy=0;
			freplica.Write(&dummy, 1);
			byteswritten++;							  
		}
	}
///////////////////////////////////////////////////////
	BITMAPFILEHEADER bmfHeader;
	DWORD dwBitsSize;
	HDIB mm_hDIB;
	LPSTR pDIB;
	freplica.SeekToBegin();
    //. t@C̃TCY擾
	dwBitsSize = freplica.GetLength();
	//. wb_[ǂݍ koreka
	if ((freplica.Read((LPSTR)&bmfHeader, sizeof(bmfHeader)) !=
		sizeof(bmfHeader)) || (bmfHeader.bfType != DIB_HEADER_MARKER))
	{
		return NULL;
	}
	//. mۂ
	mm_hDIB = (HDIB) ::GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, dwBitsSize);
	if (mm_hDIB == 0)
	{
		return NULL;
	}
    pDIB = (LPSTR) ::GlobalLock((HGLOBAL) mm_hDIB);
  /*if (freplica.ReadHuge(pDIB,*/ 
	if (freplica.Read(pDIB, 
		            dwBitsSize - sizeof(BITMAPFILEHEADER)) !=
		            dwBitsSize - sizeof(BITMAPFILEHEADER) )
	{
		::GlobalUnlock((HGLOBAL) mm_hDIB);
		::GlobalFree((HGLOBAL) mm_hDIB);
		return NULL;
	}
	::GlobalUnlock((HGLOBAL) mm_hDIB);
	m_hDIB = mm_hDIB;
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
	InitDIBData();
	EndWaitCursor();

	if (m_hDIB == NULL)
	{
		MessageBox(NULL, "DIB ǂݍ߂܂B", NULL,
						 MB_ICONINFORMATION | MB_OK);
		return FALSE;
	}
	SetModifiedFlag(FALSE);
	SetPathName(fileName);
	return TRUE;
}

BOOL CDibDoc::JPEG_writer()
{
///////////// jpg only ENTER
//jpg_write_area:
 	BITMAPFILEHEADER bmfHdr;   //. rbg}bvt@C̃wb_[
	LPBITMAPINFOHEADER lpBI;   //. DIB ̏i[p\̂̃|C^
	DWORD dwDIBSize;

	if (m_hDIB == NULL)
		return FALSE;

	lpBI = (LPBITMAPINFOHEADER) ::GlobalLock((HGLOBAL) m_hDIB);
	if (lpBI == NULL)
		return FALSE;

	if (!IS_WIN30_DIB(lpBI))	//. 3.0łȂDIB͕ۑȂ
	{
		::GlobalUnlock((HGLOBAL) m_hDIB);
		return FALSE;
	}

	//. t@C̃wb_[\̂̃f[^쐬
	bmfHdr.bfType = DIB_HEADER_MARKER;  //. t@C^Cv"BM"

	dwDIBSize = *(LPDWORD)lpBI + ::PaletteSize((LPSTR)lpBI);

	if ((lpBI->biCompression == BI_RLE8) || (lpBI->biCompression == BI_RLE4))
		dwDIBSize += lpBI->biSizeImage;		//. RLEkrbg}bv
	else
	{
		DWORD dwBmBitsSize;

		dwBmBitsSize = WIDTHBYTES((lpBI->biWidth)*((DWORD)lpBI->biBitCount)) * lpBI->biHeight;

		dwDIBSize += dwBmBitsSize;

		lpBI->biSizeImage = dwBmBitsSize;
	}
//KoKo:  
	bmfHdr.bfSize = dwDIBSize + sizeof(BITMAPFILEHEADER) - sizeof(BITMAPFILEHEADER);
	bmfHdr.bfReserved1 = 0;
	bmfHdr.bfReserved2 = 0;
//KoKo:
	bmfHdr.bfOffBits = (DWORD)sizeof(BITMAPFILEHEADER)
						+ lpBI->biSize
						+ PaletteSize((LPSTR)lpBI);
/////////////////////////////////////////////////////////////////////
	int m_bufsw = 1;
	int DisMsg  = 1;
//	BYTE *m_buf;
//////////////////////////////////////
//  CMemFile freplica(6666666);
	CMemFile freplica;
//  wb_[
	freplica.Write((LPSTR)&bmfHdr, sizeof(BITMAPFILEHEADER));
  /*freplica.WriteHuge(lpBI, dwDIBSize);*/
	freplica.Write(lpBI, dwDIBSize);
	freplica.SeekToBegin();
	BITMAP inBM;
	BYTE m1,m2;
    long filesize;
    short res1,res2;
    long pixoff;
    long bmisize;                    
    long compression;
    unsigned long sizeimage;
    long xscale, yscale;
    long colors;
    long impcol;
//  for safety
	UINT MM_width;
	UINT MM_height;
    MM_width = 0;
	MM_height = 0;
	CString m_errorText;
	m_errorText="OK";
	UINT m_bytesRead;
	m_bytesRead=0;
	FILE *fpp;
	long rc;
	rc = 0L;
	if (fpp==NULL) {
		CString msg;                    
		msg="Can't open file for reading ";
		m_errorText=msg;
	} else {
		freplica.Read((BYTE  *)&(m1),1);
		m_bytesRead+=1;
		if (rc==-1) {m_errorText="Read Error!"; }
		freplica.Read((BYTE  *)&(m2),1);
		m_bytesRead+=1;
		if (rc==-1) m_errorText="Read Error!";
		if ((m1!='B') || (m2!='M')) {
			m_errorText="Not a valid BMP File";
        }
////////////////////////////////////////////////////////////
		freplica.Read((long  *)&(filesize),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((int  *)&(res1),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((int  *)&(res2),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(pixoff),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(bmisize),4);	
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(inBM.bmWidth),4);	
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(inBM.bmHeight),4);	
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((int  *)&(inBM.bmPlanes),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((int  *)&(inBM.bmBitsPixel),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(compression),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(sizeimage),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(xscale),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(yscale),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(colors),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(impcol),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
///////////////////////////////////////////////////////////
//	i don't do RLE files
		if (compression!=BI_RGB) {
	    	m_errorText="This is a compressed file.";
	    }
		if (colors == 0) {
			colors = 1 << inBM.bmBitsPixel;
		}
////////////////////////////////////////////////////////////
// read colormap
		RGBQUAD *colormap = NULL;
		switch (inBM.bmBitsPixel) {
		case 24:
			break;
// read pallete 
		case 1:
			break;
		case 4:
			break;
		case 8:
//			break;
			colormap = new RGBQUAD[colors];
			if (colormap==NULL) {
				m_errorText="Out of memory";
			}
			int i;
			for (i=0;i<colors;i++) {
				BYTE r,g,b, dummy;
		        freplica.Read((BYTE *)&(b),1);
//KoKo:
    			m_bytesRead++;
				if (rc!=1) {
					m_errorText="Read Error!";	
					delete [] colormap;
				}
				freplica.Read((BYTE  *)&(g),1);
				m_bytesRead++;
				if (rc!=1) {
					m_errorText="Read Error!";	
					delete [] colormap;
				}
				freplica.Read((BYTE  *)&(r),1);
				m_bytesRead++;
				if (rc!=1) {
					m_errorText="Read Error!";	
					delete [] colormap;
				}
				freplica.Read((BYTE  *)&(dummy),1);
				m_bytesRead++;
				if (rc!=1) {
					m_errorText="Read Error!";	
					delete [] colormap;
				}
				colormap[i].rgbRed=r;
				colormap[i].rgbGreen=g;
				colormap[i].rgbBlue=b;
			}
			break;
		}
		if ((long)m_bytesRead>pixoff) {
			m_errorText="Corrupt palette";
			delete [] colormap;
		}
//KoKo:
		while ((long)m_bytesRead<pixoff) {
			char dummy;
			freplica.Read(&dummy,1);
			m_bytesRead++;
		}
		int w=inBM.bmWidth;
		int h=inBM.bmHeight;
// set the output params
		MM_width = w;
		MM_height = h;
		long row_size = w * 3;
		long bufsize = (long)w * 3 * (long)h;
//KoKo:
////////////////////////////////////////////////////////////
// alloc our buffer
		m_buf=(BYTE *) new BYTE [bufsize];
		if (m_buf==NULL) {
			m_errorText="Memory alloc Failed";
		} else {
////////////////////////////////////////////////////////////
//	read it
			long row=0;
			long rowOffset=0;
// read rows in reverse order
			for (row=inBM.bmHeight-1;row>=0;row--) {
// which row are we working on?
				rowOffset=(long unsigned)row*row_size;						      
				if (inBM.bmBitsPixel==24) {
					for (int col=0;col<w;col++) {
						long offset = col * 3;
						char pixel[3];
                        if 	(freplica.Read((void  *)(pixel),3)==3) {
// we swap red and blue here
							*(m_buf + rowOffset + offset + 0)=pixel[2];// r
							*(m_buf + rowOffset + offset + 1)=pixel[1];// g
							*(m_buf + rowOffset + offset + 2)=pixel[0];// b
						}
					}
					m_bytesRead+=row_size;
// read DWORD padding
					while ((m_bytesRead-pixoff)&3) {
						char dummy;
						if (freplica.Read(&dummy,1)!=1) {
							m_errorText="Read Error";
							delete [] m_buf;
						}
                        if (m_buf==NULL) 
						{
                           AfxMessageBox
						  ("m_buf nothing Write Error...@");
						}
						m_bytesRead++;
					}
				} else {	// 1, 4, or 8 bit image
////////////////////////////////////////////////////////////////
// pixels are packed as 1 , 4 or 8 bit vals. need to unpack them
					int bit_count = 0;
					UINT mask = (1 << inBM.bmBitsPixel) - 1;
					BYTE inbyte=0;
					for (int col=0;col<w;col++) {
						int pix=0;
// if we need another byte
						if (bit_count <= 0) {
							bit_count = 8;
						    if (freplica.Read(&inbyte,1)!=1) {
							    m_errorText="Read Error";
								delete [] m_buf;
								delete [] colormap;
	                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
			                       ("m_buf nothing Write Error...A");
								}
							}
							m_bytesRead++;
						}
// keep track of where we are in the bytes
						bit_count -= inBM.bmBitsPixel;
						pix = ( inbyte >> bit_count) & mask;
// lookup the color from the colormap - stuff it in our buffer
// swap red and blue
			*(m_buf + rowOffset + col * 3 + 2) = colormap[pix].rgbBlue;
			*(m_buf + rowOffset + col * 3 + 1) = colormap[pix].rgbGreen;
			*(m_buf + rowOffset + col * 3 + 0) = colormap[pix].rgbRed;
					}
// read DWORD padding
					while ((m_bytesRead-pixoff)&3) {
						char dummy;
						if (freplica.Read(&dummy,1)!=1) {
							m_errorText="Read Error";
							delete [] m_buf;
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
			                       ("m_buf nothing Write Error...B");
								}
							if (colormap)
								delete [] colormap;
						}
//KoKo:
    						m_bytesRead++;
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
			   	                   ("m_buf nothing Write Error...C");
								}
					}
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
				                   ("m_buf nothing Write Error...D");
								}
				}
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
				                   ("m_buf nothing Write Error...E");
								}
			}
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
				                   ("m_buf nothing Write Error...F");
								}
		}
		if (colormap) {
			delete [] colormap;
		}
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
			                       ("m_buf nothing Write Error...G");
								}
    }
    if ((m_buf==NULL) && (DisMsg == 1))
	{
        AfxMessageBox("m_buf nothing Write Error...H");
	}
//	JpegFile::BGRFromRGB(m_buf, lpBI->biWidth , lpBI->biHeight);
//	JpegFile::VertFlipBuf(m_buf, lpBI->biWidth  * 3, lpBI->biHeight);
/////////////////////////////////////  H13.08/14 ADD m_buf ReMake END
/////////////////////////////////////////////////////////////////////
	// we vertical flip for display. undo that.
	JpegFile::VertFlipBuf(m_buf, lpBI->biWidth * 3, lpBI->biHeight);
	// we swap red and blue for display, undo that.
	JpegFile::BGRFromRGB(m_buf, lpBI->biWidth, lpBI->biHeight);
//  ̒ open/close
	BOOL ok=JpegFile::RGBToJpegFile(fileName, 
									m_buf,
									lpBI->biWidth,
									lpBI->biHeight,
									TRUE, 
									75);			// quality value 1-100.
	::GlobalUnlock((HGLOBAL) m_hDIB);
///////////// jpg only EXIT
	EndWaitCursor();
	SetModifiedFlag(FALSE);
    return TRUE;
}

/////////////////////////////////
void CDibDoc::OnEditCopy3R_DOC()
{
//	CDibDoc* pDoc = GetDocument();
	// Nbv{[h̓e DIB Rs[܂B

//	if (OpenClipboard())
//	{
//		BeginWaitCursor();
//		EmptyClipboard();
//		SetClipboardData (CF_DIB, CopyHandle((HANDLE) pDoc->GetHDIB()) );
//		CloseClipboard();
//		EndWaitCursor();
//	}
/////////////////////
	CDC* pDC;
//  CDC *pDC = GetDC();

    DrawCopy3R_DOC(pDC);

//	ReleaseDC(pDC);
}

void CDibDoc::OnUpdateEditCopy3R_DOC(CCmdUI* pCmdUI)
{
//	pCmdUI->Enable(GetHDIB() != NULL);
	pCmdUI->Enable(m_buf != NULL);
}

void CDibDoc::DrawCopy3R_DOC(CDC* pDC)
{

//	CDibDoc* pDoc = GetDocument();

	CSize m_sizeDoc = GetDocSize();
	m_width  = m_sizeDoc.cx;
	m_height = m_sizeDoc.cy;


}
//////////////////////////

/////////////////////////////////////////////////////////////////////////////
// CDibDoc NX̐ff

#ifdef _DEBUG
void CDibDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDibDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDibDoc R}h
