// dibdoc.h : interface of the CDibDoc class
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// ̃\[X R[h Microsoft Foundation Class t@XсA
// ֘AIC hLg̕⑫݂̂ړIƂĂ܂B
// Microsoft Foundation Class iɊւڂ͂̃hLg
// QƂĂB
//

#include "dibapi.h"

class CDibDoc : public CDocument
{
protected: // VACY@\݂̂쐬܂B
	CDibDoc();
	DECLARE_DYNCREATE(CDibDoc)

// Agr[g
public:
	HDIB GetHDIB() const
		{ return m_hDIB; }
	CPalette* GetDocPalette() const
		{ return m_palDIB; }
	CSize GetDocSize() const
		{ return m_sizeDoc; }

	LPBITMAPFILEHEADER  GetFileHeader() const
	{ return m_lpBMFH; }

    LPBITMAPINFOHEADER  GetInfoHeader() const
	{ return m_lpBMIH; }

    LPBITMAPINFO        GetInfo() const
    { return m_lpBMI; }

	BYTE* Getm_buf() const
	{ return m_buf; }
	
	CString Get_fileName() const
	{ return fileName; }	
// Iy[V
public:
	void ReplaceHDIB(HDIB hDIB);
	void InitDIBData();

	void DrawCopy3R_DOC(CDC* pDC);

// Cve[V
protected:
	virtual ~CDibDoc();

	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);

protected:
	HDIB m_hDIB;
	CPalette* m_palDIB;
	CSize m_sizeDoc;

//pointers for internal use
    LPBITMAPFILEHEADER m_lpBMFH;
    LPBITMAPINFOHEADER m_lpBMIH;
    LPBITMAPINFO       m_lpBMI;
//  LPSTR              m_lpData; 

	BYTE *m_buf;
	UINT m_width;
	UINT m_height;
//	UINT m_widthDW;
	CString fileName;

    UINT jpeg_SW; 

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
protected:
	virtual BOOL    OnNewDocument();
    virtual BOOL    JPEG_reader();
	virtual BOOL    JPEG_writer();
// ꂽbZ[W }bv֐
protected:
	//{{AFX_MSG(CDibDoc)
	afx_msg void OnEditCopy3R_DOC();
	afx_msg void OnUpdateEditCopy3R_DOC(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
