// dibview.cpp : CDibView NX̃Cve[V
//
// This is a part of the Microsoft Foundation Classes C++ library.
// Copyright (C) 1992-1998 Microsoft Corporation
// All rights reserved.
//
// ̃\[X R[h Microsoft Foundation Class t@XсA
// ֘AIC hLg̕⑫݂̂ړIƂĂ܂B
// Microsoft Foundation Class iɊւڂ͂̃hLg
// QƂĂB
//

#include "stdafx.h"

//#include <windowsx.h>  // for GlobalAllocPtr

#include "diblook.h"

#include "dibdoc.h"
#include "dibview.h"
#include "dibapi.h"
#include "mainfrm.h"

#include "jpegfile.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

#define DIB_HEADER_MARKER   ((WORD) ('M' << 8) | 'B')
/////////////////////////////////////////////////////////////////////////////
// CDibView

IMPLEMENT_DYNCREATE(CDibView, CScrollView)

BEGIN_MESSAGE_MAP(CDibView, CScrollView)
	//{{AFX_MSG_MAP(CDibView)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)

	ON_COMMAND(ID_EDIT_COPY3, OnEditCopy3)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY3, OnUpdateEditCopy3)
	ON_COMMAND(ID_EDIT_COPY3R, OnEditCopy3R)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY3R, OnUpdateEditCopy3R)
	ON_COMMAND(ID_EDIT_COPY3RD21, OnEditCopy3RD21)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY3RD21, OnUpdateEditCopy3RD21)

	ON_COMMAND(ID_EDIT_COPY3RD, OnEditCopy3RD)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY3RD, OnUpdateEditCopy3RD)
	ON_COMMAND(ID_EDIT_COPY3RD20, OnEditCopy3RD20)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY3RD20, OnUpdateEditCopy3RD20)
	ON_COMMAND(ID_EDIT_COPY3RDB, OnEditCopy3RDB)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY3RDB, OnUpdateEditCopy3RDB)

	ON_COMMAND(ID_EDIT_PASTE_CF_BMP, OnEditPasteCBIT)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE_CF_BMP, OnUpdateEditPasteCBIT)

	ON_MESSAGE(WM_DOREALIZE, OnDoRealize)
	//}}AFX_MSG_MAP

	// ẄR}h
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDibView NX̍\z/

CDibView::CDibView()
{
	m_buf = NULL;
	m_width=0;		// image dimensions
	m_height=0;		// image dimensions
	m_widthDW=0;
}

CDibView::~CDibView()
{
}

/////////////////////////////////////////////////////////////////////////////
// CDibView NX̕`

void CDibView::OnDraw(CDC* pDC)
{
    int left = 0;
	int top = 0;
	left = top = 30;
    CPoint SCRpoint =
           GetDeviceScrollPosition();
	int w = left - SCRpoint.x;
    int h = top  - SCRpoint.y;
	CSize m_sizeView;
	m_sizeView.cx = m_width + 60;
	m_sizeView.cy = m_height + 60;
//	if (m_buf != NULL) {
//	    SetScrollSizes(MM_TEXT, GetDocument()->GetDocSize());
//    	SetScrollSizes(MM_TEXT, m_sizeView);
//	}
////////////////////////////////////////////
	CDC *theDC = GetDC();
    CClientDC pM(this);

	int lines = SetStretchBltMode(pM.m_hDC, HALFTONE);
	BYTE *tmp;
	// set up a DIB 
	BITMAPINFOHEADER bmiHeader;
	bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmiHeader.biWidth = m_width;
	bmiHeader.biHeight = m_height;
	bmiHeader.biPlanes = 1;
	bmiHeader.biBitCount = 24;
	bmiHeader.biCompression = BI_RGB;
	bmiHeader.biSizeImage = 0;
	bmiHeader.biXPelsPerMeter = 0;
	bmiHeader.biYPelsPerMeter = 0;
	bmiHeader.biClrUsed = 0;
	bmiHeader.biClrImportant = 0;
    if (m_buf == NULL) goto bypass_ondraw;
		// DWORD-align for display
	tmp = JpegFile::MakeDwordAlignedBuf(m_buf,
    									m_width,
										m_height,
										&m_widthDW);

    lines = StretchDIBits(pM.m_hDC,
	    					  w, h,
							  bmiHeader.biWidth,
							  bmiHeader.biHeight,
							  0,   0,
						   	  bmiHeader.biWidth,
							  bmiHeader.biHeight,
							  tmp,
							  (LPBITMAPINFO)&bmiHeader,
							  DIB_RGB_COLORS,
							  SRCCOPY);
    return;
////////////////////////////////////////////
bypass_ondraw:
	CDibDoc* pDoc = GetDocument();

	HDIB hDIB = pDoc->GetHDIB();
	if (hDIB != NULL)
	{
		LPSTR lpDIB = (LPSTR) ::GlobalLock((HGLOBAL) hDIB);
		int cxDIB = (int) ::DIBWidth(lpDIB);         // DIB ̃TCY - x
		int cyDIB = (int) ::DIBHeight(lpDIB);        // DIB ̃TCY - y
		::GlobalUnlock((HGLOBAL) hDIB);
		CRect rcDIB;
		rcDIB.top = rcDIB.left = 0;
		rcDIB.right = cxDIB;
		rcDIB.bottom = cyDIB;
		CRect rcDest;
		if (pDC->IsPrinting())   // v^ DC
		{
			// v^ y[W̃TCY擾܂ (sNZ)
			int cxPage = pDC->GetDeviceCaps(HORZRES);
			int cyPage = pDC->GetDeviceCaps(VERTRES);
			// C`̃v^ sNZ擾܂B
			int cxInch = pDC->GetDeviceCaps(LOGPIXELSX);
			int cyInch = pDC->GetDeviceCaps(LOGPIXELSY);

			//
			// xXg tBbgP[X -- DIB ̃AXyNgŎlp`쐬
			// y[W̐ɏĂ܂B
			//
			// "->bottom" tB[h͈̉̐rbg}bv Y
			// |WVrbg}bṽTCYAy[W̕A֘A
			// ̃sNZ(cyInch / cxInch)TCYɊÂČvZ܂B
			// 
			//
			rcDest.top = rcDest.left = 0;
			rcDest.bottom = (int)(((double)cyDIB * cxPage * cyInch)
					/ ((double)cxDIB * cxInch));
			rcDest.right = cxPage;
		}
		else   // v^ DC ł͂܂B
		{
			rcDest = rcDIB;
		}
		::PaintDIB(pDC->m_hDC, &rcDest, pDoc->GetHDIB(),
			&rcDIB, pDoc->GetDocPalette());
	}
}

/////////////////////////////////////////////////////////////////////////////
// CDibView NẌ

BOOL CDibView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// ftHg̈
	return DoPreparePrinting(pInfo);
}

/////////////////////////////////////////////////////////////////////////////
// CDibView R}h


LRESULT CDibView::OnDoRealize(WPARAM wParam, LPARAM)
{
	ASSERT(wParam != NULL);
	CDibDoc* pDoc = GetDocument();
	if (pDoc->GetHDIB() == NULL)
		return 0L;  // VKhLg

	CPalette* pPal = pDoc->GetDocPalette();
	if (pPal != NULL)
	{
		CMainFrame* pAppFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
		ASSERT_KINDOF(CMainFrame, pAppFrame);

		CClientDC appDC(pAppFrame);
		// ׂẴr[̓ 1 ͔wip̃pbgłB
		// wParam ̓ANeBuȃr[̃nh܂ނ̂ŁASelectPalette
		// bForceBackground tO wParam == m_hWnd (̃r[) ̏ꍇ FALSE łB 
		CPalette* oldPalette = appDC.SelectPalette(pPal, ((HWND)wParam) != m_hWnd);

		if (oldPalette != NULL)
		{
			UINT nColorsChanged = appDC.RealizePalette();
			if (nColorsChanged > 0)
				pDoc->UpdateAllViews(NULL);
			appDC.SelectPalette(oldPalette, TRUE);
		}
		else
		{
			TRACE0("\tSelectPalette failed in CDibView::OnPaletteChanged\n");
		}
	}

	return 0L;
}

void CDibView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();
	ASSERT(GetDocument() != NULL);
	CSize m_sizeView;
	m_sizeView = GetDocument()->GetDocSize();
	m_sizeView.cx = m_sizeView.cx + 60;
	m_sizeView.cy = m_sizeView.cy + 60;
//	SetScrollSizes(MM_TEXT, GetDocument()->GetDocSize());
	SetScrollSizes(MM_TEXT, m_sizeView);
}


void CDibView::OnActivateView(BOOL bActivate, CView* pActivateView,
					CView* pDeactiveView)
{
	CScrollView::OnActivateView(bActivate, pActivateView, pDeactiveView);

	if (bActivate)
	{
		ASSERT(pActivateView == this);
		OnDoRealize((WPARAM)m_hWnd, 0);   // SendMessage(WM_DOREALIZE) Ɠl;
	}
}

void CDibView::OnEditCopy()
{
	CDibDoc* pDoc = GetDocument();
	// Nbv{[h̓e DIB Rs[܂B

	if (OpenClipboard())
	{
		BeginWaitCursor();
		EmptyClipboard();
		SetClipboardData (CF_DIB, CopyHandle((HANDLE) pDoc->GetHDIB()) );
		CloseClipboard();
		EndWaitCursor();
	}

	Invalidate(TRUE);

}

void CDibView::OnUpdateEditCopy(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->GetHDIB() != NULL);
}

void CDibView::OnEditPaste()
{
    VERIFY(OpenClipboard());
    HBITMAP hBitmap = (HBITMAP) ::GetClipboardData(CF_DIB);
    CBitmap* cclpBitmap = CBitmap::FromHandle((HBITMAP)::GetClipboardData(CF_DIB));
//  temporary object
    VERIFY(::CloseClipboard());

    if (!hBitmap) {
		AfxMessageBox("Clip_Board NOT CF_DIB  TRY  PASTE_CBIT !");
		return;
	}


	HDIB hNewDIB = NULL;

	if (OpenClipboard())
	{
		BeginWaitCursor();

		hNewDIB = (HDIB) CopyHandle(::GetClipboardData(CF_DIB));

		CloseClipboard();

		if (hNewDIB != NULL)
		{
			CDibDoc* pDoc = GetDocument();
			pDoc->ReplaceHDIB(hNewDIB); // Â DIB ܂B
			pDoc->InitDIBData();    // VTCYуpbg̐ݒ
			pDoc->SetModifiedFlag(TRUE); 

	        CSize m_sizeView;
			m_sizeView = GetDocument()->GetDocSize();
	        m_sizeView.cx = m_sizeView.cx + 60;
	        m_sizeView.cy = m_sizeView.cy + 60;
//	        SetScrollSizes(MM_TEXT, GetDocument()->GetDocSize());
	        SetScrollSizes(MM_TEXT, m_sizeView);
			OnDoRealize((WPARAM)m_hWnd,0);  // VKpbg܂B
			pDoc->UpdateAllViews(NULL);
		}
		EndWaitCursor();
	}

	Invalidate(TRUE);
}

void CDibView::OnUpdateEditPaste(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(::IsClipboardFormatAvailable(CF_DIB));
}

///////////////////////////////////////////////////////////
void CDibView::OnEditCopy3()
{

    CDC *pDC = GetDC();

    DrawCopy3(pDC);

	ReleaseDC(pDC);

	Invalidate(TRUE);
}

void CDibView::OnUpdateEditCopy3(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->GetHDIB() != NULL);
}

void CDibView::OnEditCopy3R()
{

    CDC *pDC = GetDC();

    DrawCopy3R(pDC);

	ReleaseDC(pDC);

	Invalidate(TRUE);
}

void CDibView::OnUpdateEditCopy3R(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(GetDocument()->GetHDIB() != NULL);
}

void CDibView::OnEditCopy3RD21()
{
	if (m_buf == NULL) {
		AfxMessageBox("CDC_Display None Copy 1 Error!");
		return;
	}

	CDC pzM;

	CDC *theDC = GetDC();

	pzM.CreateCompatibleDC(theDC);

    CBitmap* SourceSizeBitmap = new CBitmap;

	UINT workcx;
	UINT workcy;
    //  draw the BMP we have in memory
	BYTE *tmp;
	//  DWORD-align for display
	UINT Dibb_Sw = 1;
    if (Dibb_Sw == 1) {
		    	tmp = JpegFile::MakeDwordAlignedBuf(m_buf,
										 m_width,
										 m_height,
										 &m_widthDW);
		}
		else
		{

		}
    // set up a DIB 
	BITMAPINFOHEADER bmiHeader;
	bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmiHeader.biWidth = m_width;
	bmiHeader.biHeight = m_height;
	bmiHeader.biPlanes = 1;
	bmiHeader.biBitCount = 24;
	bmiHeader.biCompression = BI_RGB;
	bmiHeader.biSizeImage = 0;
	bmiHeader.biXPelsPerMeter = 0;
	bmiHeader.biYPelsPerMeter = 0;
	bmiHeader.biClrUsed = 0;
	bmiHeader.biClrImportant = 0;

	workcx = m_width;
	workcy = m_height;

	SourceSizeBitmap->CreateCompatibleBitmap(theDC, workcx, workcy);

	CBitmap* OldBitmap =                                 // 
         (CBitmap*) pzM.SelectObject(SourceSizeBitmap);  //

	Dibb_Sw = 0;
	if (Dibb_Sw == 0) {
	    int linesss = StretchDIBits(pzM.GetSafeHdc(),
	                                0, 0,
									workcx,
									workcy,
									0,0,
									workcx,
									workcy,
									tmp,
									(LPBITMAPINFO)&bmiHeader,
									DIB_RGB_COLORS,
									SRCCOPY);
	}

    if (m_buf == NULL) {
		AfxMessageBox("CDC_Display None Copy 1 Error!");
		return;
	}

	VERIFY(OpenClipboard());
    VERIFY(::EmptyClipboard());
	VERIFY(::SetClipboardData(CF_BITMAP,SourceSizeBitmap->Detach()));
	VERIFY(::CloseClipboard());

	ReleaseDC(theDC);     
    delete SourceSizeBitmap;
//	delete nwBitmap;  //ΕKv
	delete [] tmp; /////// ꂪȂƃ[N 
/////////////////////

	Invalidate(TRUE);
}

void CDibView::OnUpdateEditCopy3RD21(CCmdUI* pCmdUI)
{
//	pCmdUI->Enable(GetDocument()->GetHDIB() != NULL);
}

void CDibView::OnEditCopy3RD()
{

    CDC *pDC = GetDC();

	DrawCopy3RD();

	Invalidate(TRUE);
}

void CDibView::OnUpdateEditCopy3RD(CCmdUI* pCmdUI)
{
//	pCmdUI->Enable(GetDocument()->GetHDIB() != NULL);
}

void CDibView::OnEditCopy3RD20()
{

    CDC *pDC = GetDC();

	DrawCopy3RD20();

	Invalidate(TRUE);
}

void CDibView::OnUpdateEditCopy3RD20(CCmdUI* pCmdUI)
{
//	pCmdUI->Enable(GetDocument()->GetHDIB() != NULL);
}

void CDibView::OnEditCopy3RDB()
{

    CDC *pDC = GetDC();

    DrawCopy3RDB();

	Invalidate(TRUE);
}

void CDibView::OnUpdateEditCopy3RDB(CCmdUI* pCmdUI)
{
//	pCmdUI->Enable(GetDocument()->GetHDIB() != NULL);
}

void CDibView::OnEditPasteCBIT()
{
	if (m_buf!=NULL) {
		delete [] m_buf;
		m_buf=NULL;
	}

    CDC *pDC = GetDC();	

    DrawPaste(pDC); // pDC (?)l肠ĂĂȂ

    // force a redraw
	Invalidate(TRUE);

	ReleaseDC(pDC);
//	return;

	Invalidate(TRUE);

}

void CDibView::OnUpdateEditPasteCBIT(CCmdUI* pCmdUI)
{
	pCmdUI->Enable(::IsClipboardFormatAvailable(CF_DIB));
}

/////////////////////////////////
void CDibView::DrawCopy3(CDC* pDC)
{

	CDibDoc* pDoc = GetDocument();

	CSize m_sizeDoc = pDoc->GetDocSize();
	m_width  = m_sizeDoc.cx;
	m_height = m_sizeDoc.cy;

	CRect rcDIB;
	rcDIB.top = rcDIB.left = 0;
	rcDIB.right = m_width;
	rcDIB.bottom = m_height;
	CRect rcDest;
	rcDest = rcDIB; 
	::PaintDIB(pDC->m_hDC, &rcDest, pDoc->GetHDIB(),
			&rcDIB, pDoc->GetDocPalette());

//////////////////////////////////////
//	void CMFCappView::DrawCopy8(CDC* pDC)  //CDC Bitmap Get
    {
	//@Ɂ@CDC  Bitmap 쐬@
    // parameters
	CDC pzM;
    CDC *theDC = GetDC();
	pzM.CreateCompatibleDC(theDC);
    CBitmap* SourceSizeBitmap = new CBitmap;
	UINT workcx;
	UINT workcy;
    workcx = m_width;
	workcy = m_height;
//////// 
	SourceSizeBitmap->CreateCompatibleBitmap(theDC, workcx, workcy);

	CBitmap* OldBitmap = 
         (CBitmap*) pzM.SelectObject(SourceSizeBitmap);

	// set up a DIB 
	BITMAPINFOHEADER bmiHeader;
	bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmiHeader.biWidth = m_width;
	bmiHeader.biHeight = m_height;
	bmiHeader.biPlanes = 1;
	bmiHeader.biBitCount = 24;
	bmiHeader.biCompression = BI_RGB;
	bmiHeader.biSizeImage = 0;
	bmiHeader.biXPelsPerMeter = 0;
	bmiHeader.biYPelsPerMeter = 0;
	bmiHeader.biClrUsed = 0;
	bmiHeader.biClrImportant = 0;

//  int line; 
    pzM.BitBlt(0, 0, m_width, m_height, pDC, 0, 0, SRCCOPY);  // KORE WA KARA
	if (SourceSizeBitmap) {
        VERIFY(OpenClipboard());
        VERIFY(::EmptyClipboard());
		VERIFY(::SetClipboardData(CF_BITMAP,SourceSizeBitmap->Detach()));//@[ȃG[
        VERIFY(::CloseClipboard());
    }
//////////////////////////////////////////////////////////////////////
	ReleaseDC(theDC);
	delete SourceSizeBitmap;

///////////////////////////////////////// return;
///////////////////////////////////////// return;
///////////////////////////////////////// return;
    return;
///////////////////////////////////////// return;
///////////////////////////////////////// return;
///////////////////////////////////////// return;

	UINT Dib_Sw = 1;
//  now blast it to the CDC passed in.
//  lines returns the number of lines actually displayed
//////////////////////// special for jpeg size getting
//////////////////////// KONO GYO JYUYO DESU 20000.03/08
	BITMAPINFOHEADER bmiHeader_2;
//	BITMAP bm;
	HBITMAP hBitmap = (HBITMAP)&bmiHeader_2;
////////////////////////////////////////////////////////////
	CBitmap* dummySourceSizeBitmap = new CBitmap;
	int	workcxdummy = m_width;
	int workcydummy = m_height;
	dummySourceSizeBitmap->CreateCompatibleBitmap(theDC, workcxdummy, workcydummy);

	VERIFY(OpenClipboard());
    VERIFY(::EmptyClipboard());
//	VERIFY(::SetClipboardData(CF_BITMAP,cclpBitmap->Detach()));//@[ȃG[
	VERIFY(::SetClipboardData(CF_BITMAP,SourceSizeBitmap->Detach()));//@[ȃG[
	VERIFY(::CloseClipboard());

//for release
//////////////////////////////////////
    Dib_Sw = 1;
//  delete nwBitmap;  //ΕKv
/////////////////////////////////////
    }//END OF DrawCopy8(CDC* pDC)

//	ReleaseDC(theDC);
	// force a redraw
	Invalidate(TRUE);
}// end of DrawCopy3

/////////////////////////////////
void CDibView::DrawCopy3R(CDC* pDC) // for m_buf copy 
{
	CDibDoc* pDoc = GetDocument();
	CSize m_sizeDoc = pDoc->GetDocSize();
	m_width  = m_sizeDoc.cx;
	m_height = m_sizeDoc.cy;
    m_buf = pDoc->Getm_buf();
	LPBITMAPFILEHEADER  m_lpBMFH = pDoc->GetFileHeader();
    LPBITMAPINFOHEADER  m_lpBMIH = pDoc->GetInfoHeader();
    LPBITMAPINFO        m_lpBMI  = pDoc->GetInfo();
	LPSTR      m_lpBuf;    // DIB data buffer
    LPSTR      m_lpData; 
    if (m_buf == NULL) {
		AfxMessageBox("m_buf NULL Copy Error!");
		return;
	}

//void CMfcappView::DrawCopyBigger(CDC* pDC)
//{// start of copy bigger
	CDC pzM;
	CDC *theDC = GetDC();
	pzM.CreateCompatibleDC(theDC);
    CBitmap* SourceSizeBitmap = new CBitmap;
	UINT workcx;
	UINT workcy;
	UINT widthg;
	UINT heightg;
	workcx = widthg = m_width;
	workcy = heightg = m_height;
//	{
// 		 SourceSizeBitmap->CreateCompatibleBitmap(theDC, (workcx-1), (workcy-1));
         SourceSizeBitmap->CreateCompatibleBitmap(theDC, (workcx-0), (workcy-0));
//	}
	CBitmap* OldBitmap = 
      (CBitmap*) pzM.SelectObject(SourceSizeBitmap); 
	BYTE *tmp;
//  DWORD-align for display
	UINT Dib_Sw = 0;
	if (Dib_Sw == 1) {  // what is  m_lpBuf ?
		tmp = JpegFile::MakeDwordAlignedBuf((BYTE*)m_lpBuf,
										 m_width,
										 m_height,
										 &m_widthDW);
	}
	else
	{	
		tmp = JpegFile::MakeDwordAlignedBuf(m_buf,
										 m_width,
										 m_height,
										 &m_widthDW);
	}
// set up a DIB 
	BITMAPINFOHEADER bmiHeader;
	bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmiHeader.biWidth =  m_width;
	bmiHeader.biHeight = m_height;
	bmiHeader.biPlanes = 1;
	bmiHeader.biBitCount = 24;
	bmiHeader.biCompression = BI_RGB;
	bmiHeader.biSizeImage = 0;
	bmiHeader.biXPelsPerMeter = 0;
	bmiHeader.biYPelsPerMeter = 0;
	bmiHeader.biClrUsed = 0;
	bmiHeader.biClrImportant = 0;
	CRect rect;
    GetClientRect(&rect);
	int w = rect.right;
	int h = rect.bottom;
	CPoint SCRpoint =
	       GetDeviceScrollPosition();
	int lineCLO = SetStretchBltMode(theDC->m_hDC, COLORONCOLOR);
    lineCLO = SetStretchBltMode(pzM, COLORONCOLOR);
//	if ( (mm_Width < m_width) || (mm_Height < m_height) ) {
	{
        int lineCL00 = SetStretchBltMode(theDC->m_hDC, HALFTONE);
        int lineCLO00 = SetStretchBltMode(pzM, HALFTONE);
	}
	UINT m_bufsw = 2;
//  H16.04.30@0 , 1 ...g  2...g@o
	if (m_bufsw != 2)
	{
		pzM.BitBlt(0, 0, 3000, 3000, theDC, 0, 0, BLACKNESS);// KORE WA KARA
	}
	else if (m_bufsw == 2)
	{
	    pzM.BitBlt(0, 0, 3000, 3000, theDC, 0, 0, WHITENESS);// KORE WA KARA
	}
    //V^
//  line = StretchDIBits(pzM.GetSafeHdc(),
	int line = StretchDIBits(pzM.GetSafeHdc(),
	        						0, 0,
									m_width,
									m_height,
									0, 0,
									bmiHeader.biWidth,
									bmiHeader.biHeight,
									tmp,
									(LPBITMAPINFO)&bmiHeader,
									DIB_RGB_COLORS,
									SRCCOPY);
	if (Dib_Sw == 1) {
	    line = StretchDIBits(pzM.GetSafeHdc(),
								    0, 0,
									m_width,
									m_height,
									0, 0,
									(WORD) m_lpBMIH->biWidth,
									(WORD) m_lpBMIH->biHeight,
									m_lpData,
									m_lpBMI,
									DIB_RGB_COLORS,
									SRCCOPY);
	}
    else
				{
				}
	CBitmap* OOldBitmap = 
       (CBitmap*) pzM.SelectObject(OldBitmap);
    if (OOldBitmap) {
        VERIFY(OpenClipboard());
        VERIFY(::EmptyClipboard());
        VERIFY(::SetClipboardData(CF_BITMAP, OOldBitmap->Detach()));
        VERIFY(::CloseClipboard());
     }//V^   
	ReleaseDC(theDC);
	delete SourceSizeBitmap;
//	if (tmp != NULL) {
	    delete [] tmp; /////// ꂪȂƃ[N 
//	}
//}// end of copy bigger

}// end of DrawCopy3R

//////////////////////////
//////////////////////////
//////////////////////////
void CDibView::DrawCopy3RD()        // for m_lpBuf copy 
{
    CDC *pDC = GetDC();
	CDibDoc* pDoc = GetDocument();
    LPBITMAPFILEHEADER  m_lpBMFH = NULL;
    LPBITMAPINFOHEADER  m_lpBMIH = NULL;
    LPBITMAPINFO        m_lpBMI  = NULL;
//	LPSTR      m_lpBuf;    // DIB data buffer
//  LPSTR      m_lpData; 
    if (m_buf != NULL) {
		AfxMessageBox("not m_buf NULL !! / CLEAR DONE");
		m_buf = NULL;
//		return;
	}
}// end of DrawCopy3RD

//////////////////////////
////////////////////////// m_buf remake FROM READ-AGAIN 
                                      // for m_lpBuf copy
void CDibView::DrawCopy3RD20()        // for m_lpBuf copy 
{
    CDC *pDC = GetDC();
	CDibDoc* pDoc = GetDocument();
    LPBITMAPFILEHEADER  m_lpBMFH = NULL;
    LPBITMAPINFOHEADER  m_lpBMIH = NULL;
    LPBITMAPINFO        m_lpBMI  = NULL;
//	LPSTR      m_lpBuf;    // DIB data buffer
//  LPSTR      m_lpData; 
    if (m_buf != NULL) {
//		AfxMessageBox("m_buf NULL Copy Error!");
		AfxMessageBox("not m_buf NULL !! / CLEAR DONE");
		m_buf = NULL;
//		return;
	}

// A_RTN J LAST START
//////// @rۂ@m_buf @Stype DIB @V쐬
{// A_RTN J    
//  fileName = "c:\\Cho_Bad_ITabs.bmp";
    fileName = pDoc->Get_fileName();
	CString ext=fileName.Right(4);
	if (!ext.CompareNoCase(".JPG")) 
	{
	    AfxMessageBox("not DIB !! / maybe fileName == jpg");
		return;
	}

	CFile file;
	CFileException fe;
	if (!file.Open(fileName, CFile::modeRead | CFile::shareDenyWrite, &fe))
	{
		AfxMessageBox("DIB Can't open file for reading :\n"+fileName);
		return;
	}

	HDIB m_hDIB;
	CPalette* m_palDIB;
	CSize m_sizeDoc;
	m_hDIB = NULL;
	m_palDIB = NULL;
	m_sizeDoc = CSize(1,1);     // CScrollView ܂쐬邽߂̃_~[l

	BeginWaitCursor();
	int sw = 0;
    if (sw != 1) // when sw == 0
	{
	// VACYp̌Ăяo ReadDIBFile ֐ɒu܂B
	TRY
	{
		m_hDIB = ::ReadDIBFile(file);
	}
	CATCH (CFileException, eLoad)
	{
		file.Abort(); // OX[܂B
		EndWaitCursor();
		AfxMessageBox("DIB Can't open file for reading2 :\n"+fileName);
		m_hDIB = NULL;
		return;
	}
	END_CATCH

    file.Close();

///////////////////////////////
//	InitDIBData();
//  void CDibDoc::InitDIBData()
{
	if (m_palDIB != NULL)
	{
		delete m_palDIB;
		m_palDIB = NULL;
	}
	if (m_hDIB == NULL)
	{
		return;
	}

	// hLg TCY̐ݒ
	LPSTR lpDIB = (LPSTR) ::GlobalLock((HGLOBAL) m_hDIB);
	if (::DIBWidth(lpDIB) > INT_MAX ||::DIBHeight(lpDIB) > INT_MAX)
	{
		::GlobalUnlock((HGLOBAL) m_hDIB);
		::GlobalFree((HGLOBAL) m_hDIB);
		m_hDIB = NULL;
		CString strMsg;
		AfxMessageBox("File DIB Too Big for reading3 :\n"+fileName);
		return;
	}
	m_sizeDoc = CSize((int) ::DIBWidth(lpDIB), (int) ::DIBHeight(lpDIB));
	::GlobalUnlock((HGLOBAL) m_hDIB);
	// pbg̃Rs[쐬܂B
	m_palDIB = new CPalette;
	if (m_palDIB == NULL)
	{
		// ł͖{ɏłB
		::GlobalFree((HGLOBAL) m_hDIB);
		m_hDIB = NULL;
//		return;  // NOT ERROR  NOT RETURN
	}
	if (::CreateDIBPalette(m_hDIB, m_palDIB) == NULL)
	{
		// DIB ̓pbgĂȂ\܂B
		delete m_palDIB;
		m_palDIB = NULL;
//		return;  // NOT ERROR  NOT RETURN
	}

	}//END OF  < void CDibDoc::InitDIBData() > 

	EndWaitCursor();

	if (m_hDIB == NULL)
	{
		// DIB tH[}bgł͂Ȃ\܂B
		CString strMsg;

		AfxMessageBox("File/DIB CANNOT LOAD for reading5 :\n"+fileName);
		return;
	}

} // when sw == 0 -> exit out

	m_width  = m_sizeDoc.cx;
	m_height = m_sizeDoc.cy;


 	BITMAPFILEHEADER bmfHdr;   //. rbg}bvt@C̃wb_[
	LPBITMAPINFOHEADER lpBI;   //. DIB ̏i[p\̂̃|C^
	DWORD dwDIBSize;

	if (m_hDIB == NULL)
//		return FALSE;
        return;

	lpBI = (LPBITMAPINFOHEADER) ::GlobalLock((HGLOBAL) m_hDIB);
	if (lpBI == NULL)
//		return FALSE;
        return;

	//. t@C̃wb_[\̂̃f[^쐬
	bmfHdr.bfType = DIB_HEADER_MARKER;  //. t@C^Cv"BM"

	dwDIBSize = *(LPDWORD)lpBI + ::PaletteSize((LPSTR)lpBI);

	if ((lpBI->biCompression == BI_RLE8) || (lpBI->biCompression == BI_RLE4))
		dwDIBSize += lpBI->biSizeImage;		//. RLEkrbg}bv
	else
	{
		DWORD dwBmBitsSize;

		dwBmBitsSize = WIDTHBYTES((lpBI->biWidth)*((DWORD)lpBI->biBitCount)) * lpBI->biHeight;

		dwDIBSize += dwBmBitsSize;

		lpBI->biSizeImage = dwBmBitsSize;
	}
    bmfHdr.bfSize =
		dwDIBSize + sizeof(BITMAPFILEHEADER);

	bmfHdr.bfReserved1 = 0;
	bmfHdr.bfReserved2 = 0;
	bmfHdr.bfOffBits = (DWORD)sizeof(BITMAPFILEHEADER)
						+ lpBI->biSize
						+ PaletteSize((LPSTR)lpBI);

	LPSTR    lpDIBHdr;
	LPSTR    lpDIBBits;

/////////////////////////////////////////////////////////////////////
//  BOOL WINAPI PaintDIB(HDC hDC, LPRECT lpDCRect, HDIB hDIB, LPRECT lpDIBRect,
//					CPalette* pPal)
{// START OF BOOL WINAPI PaintDIB

	BOOL     bSuccess=FALSE;
	HPALETTE hPal=NULL;
	HPALETTE hOldPal=NULL;

	if (m_hDIB == NULL)
		return;

	lpDIBHdr  = (LPSTR) ::GlobalLock((HGLOBAL) m_hDIB);
	lpDIBBits = lpDIBHdr + *(LPDWORD)lpDIBHdr + ::PaletteSize(lpDIBHdr);

//	CDC *theDC = GetDC();
    CClientDC pM(this);

	if (m_palDIB != NULL)
	{
		hPal = (HPALETTE) m_palDIB->m_hObject;
		hOldPal = ::SelectPalette(pM.m_hDC, hPal, TRUE);
	}

	::SetStretchBltMode(pM.m_hDC, COLORONCOLOR);
	

	  bSuccess = ::StretchDIBits(pM.m_hDC,				// hDC
                               0, 0,
							   m_width, m_height,
							   0, 0,
                               m_width, m_height, 
							   lpDIBBits,               // lpBits
							   (LPBITMAPINFO)lpDIBHdr,  // lpBitsInfo
							   DIB_RGB_COLORS,          // wUsage
							   SRCCOPY);                // dwROP

   ::GlobalUnlock((HGLOBAL) pM.m_hDC);

	if (hOldPal != NULL)
		::SelectPalette(pM.m_hDC, hOldPal, TRUE);
	ReleaseDC(&pM);//C ???
//  return bSuccess;
}//END OF BOOL WINAPI PaintDIB
/////////////////////////////////////////////////////////////////////
// copy & paste 
/////////////////////////////////////////////////////////////////////

    // parameters
	LPSTR      m_lpBuf;    // DIB data buffer
    int        m_nBits = 24;    // number of color bits per pixel
	DWORD      m_dwLength; // total buffer length, including file header
    int    nPaletteSize = 0;
	DWORD dwBytes;
    dwBytes = 0L;

    //pointers for internal use
    LPBITMAPFILEHEADER m_lpBMFH;
    LPBITMAPINFOHEADER m_lpBMIH;
    LPBITMAPINFO       m_lpBMI;
    LPSTR              m_lpData; 

	BeginWaitCursor();

    HBITMAP hBitmap;
	BITMAP bm;

	CDC pzM;
    CDC *theDC = GetDC();
	pzM.CreateCompatibleDC(theDC);
    CBitmap* SourceSizeBitmap = new CBitmap;
	UINT workcx;
	UINT workcy;
	workcx = m_width;
	workcy = m_height;
//////// H13.08/11 ADD END
	SourceSizeBitmap->CreateCompatibleBitmap(theDC, workcx, workcy);
	CBitmap* OldBitmap = 
         (CBitmap*) pzM.SelectObject(SourceSizeBitmap);
	// set up a DIB 
	BITMAPINFOHEADER HbmiHeader;
	HbmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	HbmiHeader.biWidth  = workcx;
	HbmiHeader.biHeight = workcy;
	HbmiHeader.biPlanes = 1;
	HbmiHeader.biBitCount = 24;
	HbmiHeader.biCompression = BI_RGB;
	HbmiHeader.biSizeImage = 0;
	HbmiHeader.biXPelsPerMeter = 0;
	HbmiHeader.biYPelsPerMeter = 0;
	HbmiHeader.biClrUsed = 0;
	HbmiHeader.biClrImportant = 0;
    int m_line; 
    m_line  = StretchDIBits(pzM.GetSafeHdc(),
                    0, 0,
					workcx, workcy,
			    	0, 0,
					m_width, m_height,
					lpDIBBits,                               // lpBits
				    (LPBITMAPINFO)lpDIBHdr,                  // lpBitsInfo
				 	DIB_RGB_COLORS,
					SRCCOPY);
	CBitmap* OOldBitmap = 
         (CBitmap*) pzM.SelectObject(OldBitmap);
	pzM.SelectObject(OOldBitmap);

	hBitmap = (HBITMAP) OOldBitmap->GetSafeHandle();
	theDC->BitBlt(0, 0, 2000, 2000, &pzM, 0, 0, SRCCOPY);
////////////////////////////////////////////////////////////
    CBitmap  * clpBitmap = CBitmap::FromHandle(hBitmap); 
// temporary object
	CBitmap *ppBitmap = (CBitmap*) pzM.SelectObject(clpBitmap);

    bm.bmWidth  = m_width;
    bm.bmHeight = m_height;

    int widthg   = bm.bmWidth;
	int heightg  = bm.bmHeight;

    // fills out row to 4-byte boundary
    m_dwLength = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) +
//               sizeof(RGBQUAD) * nPaletteSize;
                 sizeof(RGBQUAD) *    0;
	if (m_lpBuf != NULL)   {
//		GlobalFreePtr(m_lpBuf);
		m_lpBuf = NULL;
	}
	if (m_lpBuf == NULL) {
		m_lpBuf = new char[1024*10000];
	}

    m_lpBMFH = (LPBITMAPFILEHEADER) m_lpBuf;
    m_lpBMIH=(LPBITMAPINFOHEADER)(m_lpBuf + sizeof(BITMAPFILEHEADER));
    m_lpBMI = (LPBITMAPINFO) m_lpBMIH;

// set up a DIB 
    m_lpBMIH->biSize = sizeof(BITMAPINFOHEADER);
    m_lpBMIH->biWidth = bm.bmWidth;
    m_lpBMIH->biHeight = bm.bmHeight;
    m_lpBMIH->biPlanes = 1;
    m_lpBMIH->biBitCount = m_nBits; // 1, 4, 8, or 24
	m_lpBMIH->biCompression = BI_RGB;
    m_lpBMIH->biSizeImage = 0;
    m_lpBMIH->biXPelsPerMeter = 0;
    m_lpBMIH->biYPelsPerMeter = 0;
    m_lpBMIH->biClrUsed = 0;
    m_lpBMIH->biClrImportant = 0;

    ::GetDIBits(pzM.GetSafeHdc(), (HBITMAP) ppBitmap->GetSafeHandle(),
                0, (WORD)bm.bmHeight, NULL, m_lpBMI, DIB_RGB_COLORS);

    if (m_lpBMIH->biSizeImage == 0) {
        m_dwLength += dwBytes * bm.bmHeight;
        m_lpBMIH->biCompression = BI_RGB;
// escape route for device drivers that don't do compression
        TRACE("Can't do compression\n");
    }
    else {
        m_dwLength += m_lpBMIH->biSizeImage;
    }


    m_lpData = (LPSTR) m_lpBMIH + sizeof(BITMAPINFOHEADER) +
               sizeof(RGBQUAD) * nPaletteSize;
    m_lpBMFH->bfType = 0x4d42; // 'BM'
    m_lpBMFH->bfSize = m_dwLength;
    m_lpBMFH->bfReserved1 = 0;
    m_lpBMFH->bfReserved2 = 0;

    m_lpBMFH->bfOffBits = (LPSTR) m_lpData - m_lpBuf;

// second GetDIBits call to make DIB
    ::GetDIBits(pzM.GetSafeHdc(), (HBITMAP)
    ppBitmap->GetSafeHandle(), 0,(WORD)bm.bmHeight, m_lpData,
    m_lpBMI, DIB_RGB_COLORS);

//////////////////////////////////////
    delete SourceSizeBitmap;
//  delete nwBitmap;  //Kv

/////////////////// ȉ RUN_01 Ɂ@
/*
int m_bufsw = 1;
int DisMsg  = 1;
if (m_bufsw == 1)
{ //...A01@ 
//	CMemFile freplica(6666666);
	CMemFile freplica;
//	....................
//  ....................
//  ....................
	JpegFile::BGRFromRGB(m_buf, m_width, m_height);
	JpegFile::VertFlipBuf(m_buf, m_width * 3, m_height);
   	if (freplica != NULL)   {
		GlobalFreePtr(&freplica);
		freplica.Close();
	}
} //...A01*///////////////////////////////
    RUN_01( m_lpBMFH, m_lpBMI, m_dwLength ); 
///////////////  H13.08/14 ADD m_buf ReMake END

	if (m_lpBuf != NULL)   {
//		GlobalFreePtr(m_lpBuf);
		m_lpBuf = NULL;
	}
	::GlobalUnlock((HGLOBAL) m_hDIB); //paste ̌ 
	if (m_hDIB != NULL)
	{
		::GlobalFree((HGLOBAL) m_hDIB);
	}
	if (m_palDIB != NULL)
	{
		delete m_palDIB;
	}
//	ReleaseDC(theDC);
}// A_RTN  (TOP) END
return;  
//////////////////////////////////////////////////////
}// end of DrawCopy3RD20


/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
// for m_lpBuf copy none read-again
void CDibView::DrawCopy3RDB() // pDC  ERROR ́@
{
    CDC *pDC = GetDC();
	CDibDoc* pDoc = GetDocument();
    LPBITMAPFILEHEADER  m_lpBMFH = NULL;
    LPBITMAPINFOHEADER  m_lpBMIH = NULL;
    LPBITMAPINFO        m_lpBMI  = NULL;
//	LPSTR      m_lpBuf;    // DIB data buffer
//  LPSTR      m_lpData; 
    if (m_buf != NULL) {
//		AfxMessageBox("m_buf NULL Copy Error!");
		AfxMessageBox("not m_buf NULL !! / CLEAR DONE");
		m_buf = NULL;
//		return;
	}

// B_RTN START LAST@START 
// @rۂ@m_buf @Stype DIB @V쐬
// TOP  B_RTN J // H19.01/06
{     
//  fileName = "c:\\Cho_Bad_ITabs.bmp";
    fileName = pDoc->Get_fileName();
	CString ext=fileName.Right(4);
	if (!ext.CompareNoCase(".JPG")) 
	{
	    AfxMessageBox("not DIB !! / maybe fileName == jpg");
		return;
	}

	HDIB m_hDIB;
	CPalette* m_palDIB;
	CSize m_sizeDoc;
	m_hDIB = NULL;
	m_palDIB = NULL;
	m_sizeDoc = CSize(1,1);     // CScrollView ܂쐬邽߂̃_~[l

    m_hDIB = pDoc->GetHDIB();
	m_sizeDoc = pDoc->GetDocSize();
    m_palDIB = pDoc->GetDocPalette();

	BeginWaitCursor();
	int sw = 0;
if (sw != 1) // when sw == 0
{
	// VACYp̌Ăяo ReadDIBFile ֐ɒu܂B
//	TRY
//	{
//		m_hDIB = ::ReadDIBFile(file);
//	}
//	CATCH (CFileException, eLoad)
//	{
//		file.Abort(); // OX[܂B
//		EndWaitCursor();
//		AfxMessageBox("DIB Can't open file for reading2 :\n"+fileName);
//		m_hDIB = NULL;
//		return;
//	}
//	END_CATCH
//  file.Close();
/****************************************
//	InitDIBData();
//void CDibDoc::InitDIBData()
{

}//END OF  < void CDibDoc::InitDIBData() > 
*/////////////////////////////////////////
	EndWaitCursor();
	if (m_hDIB == NULL)
	{
		// DIB tH[}bgł͂Ȃ\܂B
		CString strMsg;

		AfxMessageBox("File/DIB CANNOT LOAD for reading5 :\n"+fileName);
		return;
	}
} // when sw == 0 -> exit out

	m_width  = m_sizeDoc.cx;
	m_height = m_sizeDoc.cy;


 	BITMAPFILEHEADER bmfHdr;   //. rbg}bvt@C̃wb_[
	LPBITMAPINFOHEADER lpBI;   //. DIB ̏i[p\̂̃|C^
	DWORD dwDIBSize;

	if (m_hDIB == NULL)
//		return FALSE;
        return;

	lpBI = (LPBITMAPINFOHEADER) ::GlobalLock((HGLOBAL) m_hDIB);
	if (lpBI == NULL)
//		return FALSE;
        return;

	//. t@C̃wb_[\̂̃f[^쐬
	bmfHdr.bfType = DIB_HEADER_MARKER;  //. t@C^Cv"BM"

	dwDIBSize = *(LPDWORD)lpBI + ::PaletteSize((LPSTR)lpBI);

	if ((lpBI->biCompression == BI_RLE8) || (lpBI->biCompression == BI_RLE4))
		dwDIBSize += lpBI->biSizeImage;		//. RLEkrbg}bv
	else
	{
		DWORD dwBmBitsSize;

		dwBmBitsSize = WIDTHBYTES((lpBI->biWidth)*((DWORD)lpBI->biBitCount)) * lpBI->biHeight;

		dwDIBSize += dwBmBitsSize;

		lpBI->biSizeImage = dwBmBitsSize;
	}
    bmfHdr.bfSize =
		dwDIBSize + sizeof(BITMAPFILEHEADER);

	bmfHdr.bfReserved1 = 0;
	bmfHdr.bfReserved2 = 0;
	bmfHdr.bfOffBits = (DWORD)sizeof(BITMAPFILEHEADER)
						+ lpBI->biSize
						+ PaletteSize((LPSTR)lpBI);

	LPSTR    lpDIBHdr;
	LPSTR    lpDIBBits;

/////////////////////////////////////////////////////////////////////
//BOOL WINAPI PaintDIB(HDC hDC, LPRECT lpDCRect, HDIB hDIB, LPRECT lpDIBRect,
//					CPalette* pPal)
//{// START OF BOOL WINAPI PaintDIB
	BOOL     bSuccess=FALSE;
	HPALETTE hPal=NULL;
	HPALETTE hOldPal=NULL;

	if (m_hDIB == NULL)
		return;

	lpDIBHdr  = (LPSTR) ::GlobalLock((HGLOBAL) m_hDIB);
	lpDIBBits = lpDIBHdr + *(LPDWORD)lpDIBHdr + ::PaletteSize(lpDIBHdr);

//	CDC *theDC = GetDC();
    CClientDC pM(this);

	if (m_palDIB != NULL)
	{
		hPal = (HPALETTE) m_palDIB->m_hObject;
		hOldPal = ::SelectPalette(pM.m_hDC, hPal, TRUE);
	}

	::SetStretchBltMode(pM.m_hDC, COLORONCOLOR);
	

	  bSuccess = ::StretchDIBits(pM.m_hDC,				// hDC
                               0, 0,
							   m_width, m_height,
							   0, 0,
                               m_width, m_height, 
							   lpDIBBits,               // lpBits
							   (LPBITMAPINFO)lpDIBHdr,  // lpBitsInfo
							   DIB_RGB_COLORS,          // wUsage
							   SRCCOPY);                // dwROP

   ::GlobalUnlock((HGLOBAL) pM.m_hDC);

	if (hOldPal != NULL)
		::SelectPalette(pM.m_hDC, hOldPal, TRUE);
	ReleaseDC(&pM);//C ???
// return bSuccess;
//}//END OF BOOL WINAPI PaintDIB

/////////////////////////////////////////////////////////////////////
// copy & paste 
/////////////////////////////////////////////////////////////////////

    // parameters
	LPSTR      m_lpBuf;    // DIB data buffer
    int        m_nBits = 24;    // number of color bits per pixel
	DWORD      m_dwLength; // total buffer length, including file header
    int    nPaletteSize = 0;
	DWORD dwBytes;
    dwBytes = 0L;

    //pointers for internal use
    LPBITMAPFILEHEADER m_lpBMFH;
    LPBITMAPINFOHEADER m_lpBMIH;
    LPBITMAPINFO       m_lpBMI;
    LPSTR              m_lpData; 

	BeginWaitCursor();

    HBITMAP hBitmap;
	BITMAP bm;

	CDC pzM;
    CDC *theDC = GetDC();
	pzM.CreateCompatibleDC(theDC);
    CBitmap* SourceSizeBitmap = new CBitmap;
	UINT workcx;
	UINT workcy;
	workcx = m_width;
	workcy = m_height;
//////// H13.08/11 ADD END
	SourceSizeBitmap->CreateCompatibleBitmap(theDC, workcx, workcy);
	CBitmap* OldBitmap = 
         (CBitmap*) pzM.SelectObject(SourceSizeBitmap);
	// set up a DIB 
	BITMAPINFOHEADER HbmiHeader;
	HbmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	HbmiHeader.biWidth  = workcx;
	HbmiHeader.biHeight = workcy;
	HbmiHeader.biPlanes = 1;
	HbmiHeader.biBitCount = 24;
	HbmiHeader.biCompression = BI_RGB;
	HbmiHeader.biSizeImage = 0;
	HbmiHeader.biXPelsPerMeter = 0;
	HbmiHeader.biYPelsPerMeter = 0;
	HbmiHeader.biClrUsed = 0;
	HbmiHeader.biClrImportant = 0;
    int m_line; 
    m_line  = StretchDIBits(pzM.GetSafeHdc(),
                    0, 0,
					workcx, workcy,
			    	0, 0,
					m_width, m_height,
					lpDIBBits,                               // lpBits
				    (LPBITMAPINFO)lpDIBHdr,                  // lpBitsInfo
				 	DIB_RGB_COLORS,
					SRCCOPY);
	CBitmap* OOldBitmap = 
         (CBitmap*) pzM.SelectObject(OldBitmap);
	pzM.SelectObject(OOldBitmap);

	hBitmap = (HBITMAP) OOldBitmap->GetSafeHandle();
	theDC->BitBlt(0, 0, 2000, 2000, &pzM, 0, 0, SRCCOPY);
////////////////////////////////////////////////////////////
//for release
////////////////////////////////////////////////////////////
    CBitmap  * clpBitmap = CBitmap::FromHandle(hBitmap); 
// temporary object
	CBitmap *ppBitmap = (CBitmap*) pzM.SelectObject(clpBitmap);

    bm.bmWidth  = m_width;
    bm.bmHeight = m_height;

    int widthg   = bm.bmWidth;
	int heightg  = bm.bmHeight;

    // fills out row to 4-byte boundary
    m_dwLength = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) +
//               sizeof(RGBQUAD) * nPaletteSize;
                 sizeof(RGBQUAD) *    0;
	if (m_lpBuf != NULL)   {
//		GlobalFreePtr(m_lpBuf);
		m_lpBuf = NULL;
	}
	if (m_lpBuf == NULL) {
		m_lpBuf = new char[1024*10000];
	}

    m_lpBMFH = (LPBITMAPFILEHEADER) m_lpBuf;
    m_lpBMIH=(LPBITMAPINFOHEADER)(m_lpBuf + sizeof(BITMAPFILEHEADER));
    m_lpBMI = (LPBITMAPINFO) m_lpBMIH;

// set up a DIB 
    m_lpBMIH->biSize = sizeof(BITMAPINFOHEADER);
    m_lpBMIH->biWidth = bm.bmWidth;
    m_lpBMIH->biHeight = bm.bmHeight;
    m_lpBMIH->biPlanes = 1;
    m_lpBMIH->biBitCount = m_nBits; // 1, 4, 8, or 24
	m_lpBMIH->biCompression = BI_RGB;
    m_lpBMIH->biSizeImage = 0;
    m_lpBMIH->biXPelsPerMeter = 0;
    m_lpBMIH->biYPelsPerMeter = 0;
    m_lpBMIH->biClrUsed = 0;
    m_lpBMIH->biClrImportant = 0;

    ::GetDIBits(pzM.GetSafeHdc(), (HBITMAP) ppBitmap->GetSafeHandle(),
                0, (WORD)bm.bmHeight, NULL, m_lpBMI, DIB_RGB_COLORS);

    if (m_lpBMIH->biSizeImage == 0) {
        m_dwLength += dwBytes * bm.bmHeight;
        m_lpBMIH->biCompression = BI_RGB;
// escape route for device drivers that don't do compression
        TRACE("Can't do compression\n");
    }
    else {
        m_dwLength += m_lpBMIH->biSizeImage;
    }


    m_lpData = (LPSTR) m_lpBMIH + sizeof(BITMAPINFOHEADER) +
               sizeof(RGBQUAD) * nPaletteSize;
    m_lpBMFH->bfType = 0x4d42; // 'BM'
    m_lpBMFH->bfSize = m_dwLength;
    m_lpBMFH->bfReserved1 = 0;
    m_lpBMFH->bfReserved2 = 0;

    m_lpBMFH->bfOffBits = (LPSTR) m_lpData - m_lpBuf;

// second GetDIBits call to make DIB
    ::GetDIBits(pzM.GetSafeHdc(), (HBITMAP)
    ppBitmap->GetSafeHandle(), 0,(WORD)bm.bmHeight, m_lpData,
    m_lpBMI, DIB_RGB_COLORS);

//////////////////////////////////////
    delete SourceSizeBitmap;
//  delete nwBitmap;  //ΕKv

    RUN_01( m_lpBMFH, m_lpBMI, m_dwLength ); 
///////////////  H13.08/14 ADD m_buf ReMake END

return;  // H18.12/13

//	if (m_lpBuf != NULL)   {
//		GlobalFreePtr(m_lpBuf);
//		m_lpBuf = NULL;
//	}
//	::GlobalUnlock((HGLOBAL) m_hDIB); //paste ̌ 
//	if (m_hDIB != NULL)
//	{
//		::GlobalFree((HGLOBAL) m_hDIB);
//	}
//	if (m_palDIB != NULL)
//	{
//		delete m_palDIB;
//	}
//	ReleaseDC(theDC);
}// TOP  B_RTN  //@H19.01/06

//return;
}// end of DrawCopy3RDB
//////////////////////////
///////////////////////////////// from 4107-13041


void CDibView::DrawPaste(CDC* pDC)  //GETDIB
{
    // parameters
    int        m_nBits;    // number of color bits per pixel
	DWORD      m_dwLength; // total buffer length, including file header
	LPSTR      m_lpBuf;    // DIB data buffer

    //pointers for internal use
    LPBITMAPFILEHEADER m_lpBMFH;
    LPBITMAPINFOHEADER m_lpBMIH;
    LPBITMAPINFO       m_lpBMI;
    LPSTR              m_lpData; 

	BeginWaitCursor();
	BITMAP bm;
////////////////////////////////////////////////////////////
    CDC pzM;
    CDC *theDC = GetDC();
	pzM.CreateCompatibleDC(theDC);
////////////////////////////////////////////////////////////
    VERIFY(OpenClipboard());
    HBITMAP hBitmap = (HBITMAP) ::GetClipboardData(CF_BITMAP);
    CBitmap* cclpBitmap = CBitmap::FromHandle((HBITMAP)::GetClipboardData(CF_BITMAP));
//  temporary object
    VERIFY(::CloseClipboard());

    if (!hBitmap) {
		AfxMessageBox("Clip_Board nothing Paste Error!");
		return;
	}

    pzM.SelectObject(cclpBitmap);//dv
	theDC->BitBlt(0, 0, 3000, 2000, &pzM, 0, 0, SRCCOPY);
//for release
////////////////////////////////////////////////////////////
    int    nPaletteSize;
    CBitmap  * clpBitmap = CBitmap::FromHandle(hBitmap); 
// temporary object
    CBitmap *nwBitmap = new CBitmap; // mem leak
	nwBitmap->Attach(hBitmap);
    nwBitmap->GetObject(sizeof(bm), &bm); // 

    m_width  = bm.bmWidth;  //
    m_height = bm.bmHeight;
    int widthg   = bm.bmWidth;
	int heightg  = bm.bmHeight;

	m_nBits = 24;
	nPaletteSize = 0;
    // fills out row to 4-byte boundary
	DWORD dwBytes;
    dwBytes = 0L;
    m_dwLength = sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) +
                 sizeof(RGBQUAD) * nPaletteSize;

	if (m_lpBuf != NULL)   {
//		GlobalFreePtr(m_lpBuf);
		m_lpBuf = NULL;
	}
	if (m_lpBuf == NULL) {
//		m_lpBuf = new char[1024*10000];
		m_lpBuf = new char[1024*30000];
		//FOR ( 2592 X 1944 ) 16Millon - 28.8Mbytes 
//		char /*huge*/ *m_lpBuf;
	}

    m_lpBMFH = (LPBITMAPFILEHEADER) m_lpBuf;
    m_lpBMIH=(LPBITMAPINFOHEADER)(m_lpBuf + sizeof(BITMAPFILEHEADER));
    m_lpBMI = (LPBITMAPINFO) m_lpBMIH;

// set up a DIB 
    m_lpBMIH->biSize = sizeof(BITMAPINFOHEADER);
    m_lpBMIH->biWidth = bm.bmWidth;
    m_lpBMIH->biHeight = bm.bmHeight;
    m_lpBMIH->biPlanes = 1;
    m_lpBMIH->biBitCount = m_nBits; // 1, 4, 8, or 24
	m_lpBMIH->biCompression = BI_RGB;
    m_lpBMIH->biSizeImage = 0;
    m_lpBMIH->biXPelsPerMeter = 0;
    m_lpBMIH->biYPelsPerMeter = 0;
    m_lpBMIH->biClrUsed = 0;
    m_lpBMIH->biClrImportant = 0;

    ::GetDIBits(pzM.GetSafeHdc(), (HBITMAP) nwBitmap/*ppBitmap*/->GetSafeHandle(),
                0, (WORD)bm.bmHeight, NULL, m_lpBMI, DIB_RGB_COLORS);

    if (m_lpBMIH->biSizeImage == 0) {
        m_dwLength += dwBytes * bm.bmHeight;
        m_lpBMIH->biCompression = BI_RGB;
// escape route for device drivers that don't do compression
        TRACE("Can't do compression\n");
    }
    else {
        m_dwLength += m_lpBMIH->biSizeImage;
    }


    m_lpData = (LPSTR) m_lpBMIH + sizeof(BITMAPINFOHEADER) +
               sizeof(RGBQUAD) * nPaletteSize;
    m_lpBMFH->bfType = 0x4d42; // 'BM'
    m_lpBMFH->bfSize = m_dwLength;
    m_lpBMFH->bfReserved1 = 0;
    m_lpBMFH->bfReserved2 = 0;

    m_lpBMFH->bfOffBits = (LPSTR) m_lpData - m_lpBuf;

//  second GetDIBits call to make DIB
    ::GetDIBits(pzM.GetSafeHdc(), (HBITMAP)
    nwBitmap->GetSafeHandle(), 0,(WORD)bm.bmHeight, m_lpData,
    m_lpBMI, DIB_RGB_COLORS);

//////////////////////////////////////
    delete nwBitmap;  //Kv

	int m_bufsw = 1;
	int DisMsg  = 1;

    if (m_bufsw == 1)
	{
//	CMemFile freplica(6666666);
	CMemFile freplica;
//  wb_[
	freplica.Write((LPSTR)m_lpBMFH, sizeof(BITMAPFILEHEADER));
  /*freplica.WriteHuge(m_lpBMI, m_dwLength);*/
	freplica.Write(m_lpBMI, m_dwLength);
	freplica.SeekToBegin();
	BITMAP inBM;
	BYTE m1,m2;
    long filesize;
    short res1,res2;
    long pixoff;
    long bmisize;                    
    long compression;
    unsigned long sizeimage;
    long xscale, yscale;
    long colors;
    long impcol;
// for safety
	UINT MM_width;
	UINT MM_height;
    MM_width = 0;
	MM_height = 0;
	CString m_errorText;
	m_errorText="OK";
	UINT m_bytesRead;
	m_bytesRead=0;
	FILE *fpp;
	long rc;
//  fpp = NULL; // G[̌ɂȂB
//	AfxMessageBox("m_buf nothing Write Error !!!");
	rc = 0L;
	if (fpp==NULL) {
		CString msg;                    
		msg="Can't open file for reading ";
		m_errorText=msg;
	} else {
		freplica.Read((BYTE  *)&(m1),1);
		m_bytesRead+=1;
		if (rc==-1) {m_errorText="Read Error!"; }
		freplica.Read((BYTE  *)&(m2),1);
		m_bytesRead+=1;
		if (rc==-1) m_errorText="Read Error!";
		if ((m1!='B') || (m2!='M')) {
			m_errorText="Not a valid BMP File";
        }
////////////////////////////////////////////////////////////
		freplica.Read((long  *)&(filesize),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((int  *)&(res1),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((int  *)&(res2),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(pixoff),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(bmisize),4);	
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(inBM.bmWidth),4);	
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(inBM.bmHeight),4);	
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((int  *)&(inBM.bmPlanes),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((int  *)&(inBM.bmBitsPixel),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(compression),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(sizeimage),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(xscale),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(yscale),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(colors),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(impcol),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
///////////////////////////////////////////////////////////
//	i don't do RLE files
		if (compression!=BI_RGB) {
	    	m_errorText="This is a compressed file.";
	    }
		if (colors == 0) {
			colors = 1 << inBM.bmBitsPixel;
		}
////////////////////////////////////////////////////////////
// read colormap
		RGBQUAD *colormap = NULL;
		switch (inBM.bmBitsPixel) {
		case 24:
			break;
// read pallete 
		case 1:
			break;
		case 4:
			break;
		case 8:
//			break;
			colormap = new RGBQUAD[colors];
			if (colormap==NULL) {
				m_errorText="Out of memory";
			}
			int i;
			for (i=0;i<colors;i++) {
				BYTE r,g,b, dummy;
		        freplica.Read((BYTE *)&(b),1);
				m_bytesRead++;
				if (rc!=1) {
					m_errorText="Read Error!";	
					delete [] colormap;
				}
				freplica.Read((BYTE  *)&(g),1);
				m_bytesRead++;
				if (rc!=1) {
					m_errorText="Read Error!";	
					delete [] colormap;
				}
				freplica.Read((BYTE  *)&(r),1);
				m_bytesRead++;
				if (rc!=1) {
					m_errorText="Read Error!";	
					delete [] colormap;
				}
				freplica.Read((BYTE  *)&(dummy),1);
				m_bytesRead++;
				if (rc!=1) {
					m_errorText="Read Error!";	
					delete [] colormap;
				}
				colormap[i].rgbRed=r;
				colormap[i].rgbGreen=g;
				colormap[i].rgbBlue=b;
			}
			break;
		}
		if ((long)m_bytesRead>pixoff) {
			m_errorText="Corrupt palette";
			delete [] colormap;
		}
		while ((long)m_bytesRead<pixoff) {
			char dummy;
//			long rcc;
			freplica.Read(&dummy,1);
			m_bytesRead++;
		}
		int w=inBM.bmWidth;
		int h=inBM.bmHeight;
// set the output params
		MM_width = w;
		MM_height = h;
		long row_size = w * 3;
		long bufsize = (long)w * 3 * (long)h;
////////////////////////////////////////////////////////////
// alloc our buffer
		m_buf=(BYTE *) new BYTE [bufsize];
		if (m_buf==NULL) {
			m_errorText="Memory alloc Failed";
		} else {
////////////////////////////////////////////////////////////
//	read it
			long row=0;
			long rowOffset=0;
// read rows in reverse order
			for (row=inBM.bmHeight-1;row>=0;row--) {
// which row are we working on?
				rowOffset=(long unsigned)row*row_size;						      
				if (inBM.bmBitsPixel==24) {
					for (int col=0;col<w;col++) {
						long offset = col * 3;
						char pixel[3];
                        if 	(freplica.Read((void  *)(pixel),3)==3) {
// we swap red and blue here
							*(m_buf + rowOffset + offset + 0)=pixel[2];// r
							*(m_buf + rowOffset + offset + 1)=pixel[1];// g
							*(m_buf + rowOffset + offset + 2)=pixel[0];// b
						}
					}
					m_bytesRead+=row_size;
// read DWORD padding
					while ((m_bytesRead-pixoff)&3) {
						char dummy;
						if (freplica.Read(&dummy,1)!=1) {
							m_errorText="Read Error";
							delete [] m_buf;
						}
                        if (m_buf==NULL) 
						{
                           AfxMessageBox
						  ("m_buf nothing Write Error @ !!!");
						}
						m_bytesRead++;
					}
				} else {	// 1, 4, or 8 bit image
////////////////////////////////////////////////////////////////
// pixels are packed as 1 , 4 or 8 bit vals. need to unpack them
					int bit_count = 0;
					UINT mask = (1 << inBM.bmBitsPixel) - 1;
					BYTE inbyte=0;
					for (int col=0;col<w;col++) {
						int pix=0;
// if we need another byte
						if (bit_count <= 0) {
							bit_count = 8;
						    if (freplica.Read(&inbyte,1)!=1) {
							    m_errorText="Read Error";
								delete [] m_buf;
								delete [] colormap;
	                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
			("m_buf nothing Write Error A !!!");
								}
							}
							m_bytesRead++;
						}
// keep track of where we are in the bytes
						bit_count -= inBM.bmBitsPixel;
						pix = ( inbyte >> bit_count) & mask;
// lookup the color from the colormap - stuff it in our buffer
// swap red and blue
			*(m_buf + rowOffset + col * 3 + 2) = colormap[pix].rgbBlue;
			*(m_buf + rowOffset + col * 3 + 1) = colormap[pix].rgbGreen;
			*(m_buf + rowOffset + col * 3 + 0) = colormap[pix].rgbRed;
					}
// read DWORD padding
					while ((m_bytesRead-pixoff)&3) {
						char dummy;
						if (freplica.Read(&dummy,1)!=1) {
							m_errorText="Read Error";
							delete [] m_buf;
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
			   ("m_buf nothing Write Error B !!!");
								}
							if (colormap)
								delete [] colormap;
						}
						m_bytesRead++;
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
			   	("m_buf nothing Write Error C !!!");
								}
					}
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
				("m_buf nothing Write Error D !!!");
								}
				}
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
				("m_buf nothing Write Error E !!!");
								}
			}
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
				("m_buf nothing Write Error F !!!");
								}
		}
		if (colormap) {
			delete [] colormap;
		}
                            if (m_buf==NULL) 
								{
                                    AfxMessageBox
			    ("m_buf nothing Write Error G !!!");
								}
    }
    if ((m_buf==NULL) && (DisMsg == 1))
	{
        AfxMessageBox("m_buf nothing Write Error !!");
	}
	JpegFile::BGRFromRGB(m_buf, m_width, m_height);
	JpegFile::VertFlipBuf(m_buf, m_width * 3, m_height);
    }

/////////////////////////////////////////////////////////
	short res1=0;
    short res2=0;
    long pixoff=54;
    long compression=0;
    long cmpsize=0;
    long colors=0;
    long impcol=0;
	char m1='B';
	char m2='M';
	CString m_errorText;
	m_errorText="OK";

	DWORD widthDW = WIDTHBYTES(m_width * 24);

	long bmfsize=sizeof(BITMAPFILEHEADER) 
	           + sizeof(BITMAPINFOHEADER) +
  						widthDW * m_height;	
	long byteswritten=0;
    long byteswritten2=0;
	BITMAPINFOHEADER header;
  	header.biSize=40; 						// header size
	header.biWidth=m_width;
	header.biHeight=m_height;
	header.biPlanes=1;
	header.biBitCount=24;					// RGB encoded, 24 bit
	header.biCompression=BI_RGB;			// no compression
	header.biSizeImage=0;
	header.biXPelsPerMeter=0;
	header.biYPelsPerMeter=0;
	header.biClrUsed=0;
	header.biClrImportant=0;


	long roww=0;
	long rowwidx;
	long roww_size;
	roww_size=header.biWidth*3;

    // DIB ̍śADWORD EŏIKv
    int bmp_row_bytes = (( ( header.biWidth * 3 ) + 3 ) / 4) * 4;
    int bmp_image_size = bmp_row_bytes * header.biHeight;
 
	// DWORD E␳
	int iHGap = bmp_row_bytes - (header.biWidth*3);

	UINT Dis_rowsize = 0;
	UINT Doc_toggle = 0;
	UINT Dis_toggle = 0;
	UINT buf_scale = 0;
//byp0:
	for (roww=0;roww<(header.biHeight+iHGap-1);roww++) {
		rowwidx=(long unsigned)roww*roww_size;						      
		// pad to DWORD
		for (DWORD count=roww_size;
             count<widthDW- sizeof(BITMAPINFOHEADER)-iHGap;count++) {
			char dummy=0;
		}
	}

	FILE *fp = NULL;
    CMemFile freplica(6666666);
	if (fp==NULL) {
		m_errorText="Can't open file for writing";
	}
// should probably check for write errors here...
	freplica.Write((BYTE  *)&m1, 1);
	freplica.Write((BYTE  *)&m2, 1);
	freplica.Write((long  *)&bmfsize, 4);
	freplica.Write((int  *)&res1, 2);
	freplica.Write((int  *)&res2, 2);
	freplica.Write((long  *)&pixoff, 4);
    byteswritten2 = byteswritten;
	freplica.Write((BITMAPINFOHEADER *)&header, sizeof(BITMAPINFOHEADER));
	byteswritten+=sizeof(BITMAPINFOHEADER);
	long row=0;
	long rowidx;
	long row_size;
	row_size=header.biWidth*3;
	for (row=0;row<header.biHeight;row++) {
		rowidx=(long unsigned)row*row_size;						      
		// write a row
    	freplica.Write((void  *)(m_buf + rowidx), row_size);
		byteswritten+=row_size;	
		// pad to DWORD
		for (DWORD count=row_size;count<widthDW;count++) {
			char dummy=0;
			freplica.Write(&dummy, 1);
			byteswritten++;							  
		}
	}
///////////////////////////////////////////////////////
	BITMAPFILEHEADER bmfHeader;
	DWORD dwBitsSize;
	HDIB mm_hDIB;
	LPSTR pDIB;
	freplica.SeekToBegin();
    //. t@C̃TCY擾
	dwBitsSize = freplica.GetLength();
	//. wb_[ǂݍ koreka
	if ((freplica.Read((LPSTR)&bmfHeader, sizeof(bmfHeader)) !=
		sizeof(bmfHeader)) || (bmfHeader.bfType != DIB_HEADER_MARKER))
	{
//		return NULL;
		return;
	}
	//. mۂ
	mm_hDIB = (HDIB) ::GlobalAlloc(GMEM_MOVEABLE | GMEM_ZEROINIT, dwBitsSize);
	if (mm_hDIB == 0)
	{
//		return NULL;
		return;
	}
    pDIB = (LPSTR) ::GlobalLock((HGLOBAL) mm_hDIB);
  /*if (freplica.ReadHuge(pDIB,*/ 
	if (freplica.Read(pDIB, 
		            dwBitsSize - sizeof(BITMAPFILEHEADER)) !=
		            dwBitsSize - sizeof(BITMAPFILEHEADER) )
	{
		::GlobalUnlock((HGLOBAL) mm_hDIB);
		::GlobalFree((HGLOBAL) mm_hDIB);
//		return NULL;
		return;
	}
	::GlobalUnlock((HGLOBAL) mm_hDIB);
//	m_hDIB = mm_hDIB;
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
	CDibDoc* pDoc = GetDocument();
//	pDoc->ReplaceHDIB(hNewDIB); // Â DIB ܂B
	pDoc->ReplaceHDIB(mm_hDIB);
	pDoc->InitDIBData();    // VTCYуpbg̐ݒ
	pDoc->SetModifiedFlag(TRUE);

//	InitDIBData();
//	EndWaitCursor();

	CSize m_sizeView;
	m_sizeView.cx = m_width + 60;
	m_sizeView.cy = m_height + 60;
//	SetScrollSizes(MM_TEXT, GetDocument()->GetDocSize());
	SetScrollSizes(MM_TEXT, m_sizeView);
	OnDoRealize((WPARAM)m_hWnd,0);  // VKpbg܂B
	pDoc->UpdateAllViews(NULL);

//	if (m_hDIB == NULL)
	if (mm_hDIB == NULL)
	{
//		MessageBox(NULL, "DIB ǂݍ߂܂B", NULL,
//						 MB_ICONINFORMATION | MB_OK);
		AfxMessageBox("DIB ǂݍ߂܂BPaste Error!");
//		return FALSE;
		return;
	}

/////////////////////////////////////
	if (m_lpBuf != NULL)   {
//		GlobalFreePtr(m_lpBuf);
//		m_lpBuf = NULL;
	}

	EndWaitCursor();

    ReleaseDC(theDC);//H17.12/20

}//DrawPaste...End

///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
void CDibView::RUN_01( LPBITMAPFILEHEADER  m_lpBMFH,
					   LPBITMAPINFO        m_lpBMI,
	                   DWORD               m_dwLength ) // 
{
/////////////////////////////////////  H13.08/14 ADD m_buf ReMake START
//  ̉ Error @NĂB // H18/12/13 AM 10:30
	int m_bufsw = 1;
	int DisMsg  = 1;
 if (m_bufsw == 1)
 { //...A01@ 
//	CMemFile freplica(6666666);
	CMemFile freplica;
//  wb_[
	freplica.Write((LPSTR)m_lpBMFH, sizeof(BITMAPFILEHEADER));
  /*freplica.WriteHuge(m_lpBMI, m_dwLength);*/
	freplica.Write(m_lpBMI, m_dwLength);

	freplica.SeekToBegin();
	BITMAP inBM;
	BYTE m1,m2;
    long filesize;
    short res1,res2;
    long pixoff;
    long bmisize;                    
    long compression;
    unsigned long sizeimage;
    long xscale, yscale;
    long colors;
    long impcol;
// for safety
	UINT MM_width;
	UINT MM_height;
    MM_width = 0;
	MM_height = 0;
	CString m_errorText;
	m_errorText="OK";
	UINT m_bytesRead;
	m_bytesRead=0;
	FILE *fpp;
	long rc;

	/// if else ͂ 
//	if (fpp==NULL) { //...B02
//		CString msg;                    
//		msg="Can't open file for reading ";
//		m_errorText=msg;
//	} else //...B02
    //...B01 START 
	{ //...B01 START 
		freplica.Read((BYTE  *)&(m1),1);
		m_bytesRead+=1;
		if (rc==-1) {m_errorText="Read Error!"; }
		freplica.Read((BYTE  *)&(m2),1);
		m_bytesRead+=1;
		if (rc==-1) m_errorText="Read Error!";
		if ((m1!='B') || (m2!='M')) { //...X01
			m_errorText="Not a valid BMP File";
        } //...X01
////////////////////////////////////////////////////////////
		freplica.Read((long  *)&(filesize),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((int  *)&(res1),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((int  *)&(res2),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(pixoff),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(bmisize),4);	
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(inBM.bmWidth),4);	
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(inBM.bmHeight),4);	
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((int  *)&(inBM.bmPlanes),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((int  *)&(inBM.bmBitsPixel),2);
		m_bytesRead+=2;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(compression),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
		freplica.Read((long  *)&(sizeimage),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(xscale),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(yscale),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(colors),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!";}
		freplica.Read((long  *)&(impcol),4);
		m_bytesRead+=4;
		if (rc!=1) {m_errorText="Read Error!"; }
///////////////////////////////////////////////////////////
//	i don't do RLE files
		if (compression!=BI_RGB) { //...ZZZ03
	    	m_errorText="This is a compressed file.";
		} //...ZZZ03
		if (colors == 0) { //...ZZZ04
			colors = 1 << inBM.bmBitsPixel;
		} //...ZZZ04
////////////////////////////////////////////////////////////
// read colormap
		RGBQUAD *colormap = NULL;
		//...SW01 ⒷXCb` START
		switch (inBM.bmBitsPixel) { //...SW01 ⒷXCb` START
		case 24:
			break;
// read pallete 
		case 1:
			break;
		case 4:
			break;
		case 8:
//			break;
			colormap = new RGBQUAD[colors];
			if (colormap==NULL) { //...X04
				m_errorText="Out of memory";
			} //...X04
			int i;
			for (i=0;i<colors;i++) { //...FW01
				BYTE r,g,b, dummy;
		        freplica.Read((BYTE *)&(b),1);
				m_bytesRead++;
				if (rc!=1) { //...X05
					m_errorText="Read Error!";	
					delete [] colormap;
				} //...X05
				freplica.Read((BYTE  *)&(g),1);
				m_bytesRead++;
				if (rc!=1) { //...X06
					m_errorText="Read Error!";	
					delete [] colormap;
				} //...X06
				freplica.Read((BYTE  *)&(r),1);
				m_bytesRead++;
				if (rc!=1) { //...X07
					m_errorText="Read Error!";	
					delete [] colormap;
				} //...X07
				freplica.Read((BYTE  *)&(dummy),1);
				m_bytesRead++;
				if (rc!=1) { //...X08
					m_errorText="Read Error!";	
					delete [] colormap;
				} //...X08
				colormap[i].rgbRed=r;
				colormap[i].rgbGreen=g;
				colormap[i].rgbBlue=b;
			} //...FW01
			break;
		} //...SW01 ⒷXCb` END

		if ((long)m_bytesRead>pixoff) { //...Z01
			m_errorText="Corrupt palette";
			delete [] colormap;
		} //...Z01

		while ((long)m_bytesRead<pixoff) { //...Z02
			char dummy;
//			long rcc;
			freplica.Read(&dummy,1);
			m_bytesRead++;
		} //...Z02

		int w=inBM.bmWidth;
		int h=inBM.bmHeight;
// set the output params
		MM_width = w;
		MM_height = h;
		long row_size = w * 3;
		long bufsize = (long)w * 3 * (long)h;
////////////////////////////////////////////////////////////
// alloc our buffer
		m_buf=(BYTE *) new BYTE [bufsize];
		if (m_buf==NULL) { //...C02
			m_errorText="Memory alloc Failed";
		} //...C02
		//...C01 START
		else { //...C01
////////////////////////////////////////////////////////////
//	read it
			long row=0;
			long rowOffset=0;
// read rows in reverse order
			//...D01 START
			for (row=inBM.bmHeight-1;row>=0;row--) { //...D01 START
// which row are we working on?
				rowOffset=(long unsigned)row*row_size;
				//...E02 ELSE݂
				if (inBM.bmBitsPixel==24) { //...E02 ELSE݂
					for (int col=0;col<w;col++) {//Y02
						long offset = col * 3;
						char pixel[3];
                        if 	(freplica.Read((void  *)(pixel),3)==3) {//X02
// we swap red and blue here
							*(m_buf + rowOffset + offset + 0)=pixel[2];// r
							*(m_buf + rowOffset + offset + 1)=pixel[1];// g
							*(m_buf + rowOffset + offset + 2)=pixel[0];// b
						}//X02
					}//Y02
					m_bytesRead+=row_size;
// read DWORD padding
					while ((m_bytesRead-pixoff)&3) {//ZZ02
						char dummy;
						if (freplica.Read(&dummy,1)!=1) {//Z02
							m_errorText="Read Error";
							delete [] m_buf;
						}//Z02
						m_bytesRead++;
					}//ZZ02
				} else  //...E02 if 
				//...E01 START 
				{	// 1, 4, or 8 bit image  //...E01 START
////////////////////////////////////////////////////////////////
// pixels are packed as 1 , 4 or 8 bit vals. need to unpack them
					int bit_count = 0;
					UINT mask = (1 << inBM.bmBitsPixel) - 1;
					BYTE inbyte=0;
					for (int col=0;col<w;col++) { //...H01
						int pix=0;
                        // if we need another byte
						if (bit_count <= 0) { //...I01
							bit_count = 8;
							if (freplica.Read(&inbyte,1)!=1) { //...J01
							    m_errorText="Read Error";
								delete [] m_buf;
								delete [] colormap;
							} //...J01
							m_bytesRead++;
						} //...I01
            // keep track of where we are in the bytes
						bit_count -= inBM.bmBitsPixel;
						pix = ( inbyte >> bit_count) & mask;
            // lookup the color from the colormap - stuff it in our buffer
            // swap red and blue
			*(m_buf + rowOffset + col * 3 + 2) = colormap[pix].rgbBlue;
			*(m_buf + rowOffset + col * 3 + 1) = colormap[pix].rgbGreen;
			*(m_buf + rowOffset + col * 3 + 0) = colormap[pix].rgbRed;
					} //...H01
                    // read DWORD padding
					while ((m_bytesRead-pixoff)&3) { //...F01
						char dummy;
						if (freplica.Read(&dummy,1)!=1) { //...G01
							m_errorText="Read Error";
							delete [] m_buf;
							if (colormap)
								delete [] colormap;
						} //...G01
						m_bytesRead++;
					} //...F01

				} //...E01
			} //...D01
		} //...C01

		if (colormap) { //...Q01
			delete [] colormap;
		} //...Q01

    } //...B01

    if ((m_buf==NULL) && (DisMsg == 1))	{
        AfxMessageBox("m_buf nothing Write Error ni naru!!!");
	}

	JpegFile::BGRFromRGB(m_buf, m_width, m_height);
	JpegFile::VertFlipBuf(m_buf, m_width * 3, m_height);
   	if (freplica != NULL)   {
//		GlobalFreePtr(&freplica);
		freplica.Close();
	}
 } //...A01   ////2001.09/26 add end
}